﻿
var autoExportPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("ae.prefid.");

var localize = document.getElementById("autoExport");

var timerActive_normal = 0;
var timerActive_backup = 0;

// function for file handle
function autoExportSaveEventsToFile(calendarEventArray, calendarName, mode, exportFormat)
{

  var localize = document.getElementById("autoExport");
  
  if (!calendarEventArray) return;

  if (!calendarEventArray.length) return;
  
  // get the directory for Export
	var dirForExport = autoExportPrefs.getCharPref(mode + ".directory");
  
  // create the path witz directory and file
	var pathForExport = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
  pathForExport.initWithPath(dirForExport);
	
  if(mode == "normal")
    pathForExport.append(calendarName + "." + exportFormat);
  else if(mode == "backup"){
    var date = new Date();
    var monthArray = new Array("01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12");
    var dayArray = new Array("00", "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31");
    pathForExport.append(calendarName + "_" + date.getFullYear() + "-" + monthArray[date.getMonth()] + "-" + dayArray[date.getDate()] + "." + exportFormat);
  }
  
  // select the export format   
  switch (exportFormat) {
    case "ics":
      var exporter = Components.classes["@mozilla.org/calendar/export;1?type=ics"].getService(Components.interfaces.calIExporter);
      break;
    case "html":
      var exporter = Components.classes["@mozilla.org/calendar/export;1?type=htmllist"].getService(Components.interfaces.calIExporter);
      break;
    case "csv":
      var exporter = Components.classes["@mozilla.org/calendar/export;1?type=csv"].getService(Components.interfaces.calIExporter);
      break;
    default:
      var exporter = Components.classes["@mozilla.org/calendar/export;1?type=ics"].getService(Components.interfaces.calIExporter);
      break;
  }
   
  var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
  try{
    outputStream.init(pathForExport, MODE_WRONLY | MODE_CREATE | MODE_TRUNCATE, 0664, 0);
    exporter.exportToStream(outputStream, calendarEventArray.length, calendarEventArray, null);
    outputStream.close();
    if (mode == "backup")
    {
      var numOfBackups = autoExportPrefs.getIntPref("backup.counter") + 1;
      deleteOldBackups(dirForExport, calendarName, numOfBackups);
    }
  }catch(ex){
    showError(calGetString("calendar", "unableToWrite") + pathForExport.path );
  }
}


// function for export the events
function autoExportEntireCalendar(calendarToExport, mode) {
  
  var itemArray = [];
  function getItemsFromCal(calToExport) {
      calToExport.getItems(Components.interfaces.calICalendar.ITEM_FILTER_ALL_ITEMS,
                    0, null, null, getListener);
  }		
  var getListener = {
    onOperationComplete: function(calendarToExport, aStatus, aOperationType, aId, aDetail)
    {
      // get the export format from preferences
      if (autoExportPrefs.getBoolPref(mode + ".exportFormat.ics"))
        autoExportSaveEventsToFile(itemArray, calendarToExport.name, mode, "ics");
        
      if (autoExportPrefs.getBoolPref(mode + ".exportFormat.html"))
        autoExportSaveEventsToFile(itemArray, calendarToExport.name, mode, "html");
        
      if (autoExportPrefs.getBoolPref(mode + ".exportFormat.csv"))
        autoExportSaveEventsToFile(itemArray, calendarToExport.name, mode, "csv");
        
    },
    onGetResult: function(calendarToExport, aStatus, aItemType, aDetail, aCount, aItems)
    {
      for each (item in aItems)
        itemArray.push(item);   
    }
  };
  getItemsFromCal(calendarToExport);
}

function autoExportOnClose(){
  if(autoExportPrefs.getBoolPref("normal.exportonclose") == true)
    autoExport("normal");
  
  if(autoExportPrefs.getBoolPref("backup.exportonclose") == true)
    autoExport("backup");   
}

function autoExportOnButton(mode){

  var localize = document.getElementById("autoExport");
  try
  {
    autoExport(mode);
  }
  catch(e)
  {
    alert(localize.getString( mode + '_error'));
  }
  return true;
}

// function to export 
function autoExport(mode){	
  
  var localize = document.getElementById("autoExport");
  
  if (autoExportPrefs.getCharPref(mode + ".directory") == ""){ 
    alert(localize.getString('err_nodir'));
    return false;
  }
  
  var calendars = getCalendarManager().getCalendars({});
	
  // get calendar by his name (string)
	function getCalendarByName(calendarName) {
    for each (var cal in calendars) {
        if (cal.name == calendarName)
          return cal;       
    }
    dump("No calendar with name: "+aName+'!\n');
    return null;
	}
	// export
	// export all calendars if the checkbox in the preferences is checked""
  if(autoExportPrefs.getBoolPref(mode + ".exportCalendars.allCalendars") == true)
    for each (var cal in calendars)
      autoExportEntireCalendar(cal, mode);

  // else export all calendars which are stored in the textbox 
  else{
    var calendarsToExport = autoExportPrefs.getCharPref(mode + ".exportCalendars.calendars");
    if (calendarsToExport == "")
      return true;
    var calArray = calendarsToExport.split(";");
    
    for(var i = 0; i < calArray.length; i++){
      autoExportEntireCalendar(getCalendarByName(calArray[i]), mode);
    }
  }
  
  if (autoExportPrefs.getBoolPref(mode + ".startApplication.activate") == true)
    ae_startApp(mode);
  
  return true;
}

function purgeBackupsByType(files, calName, dir, numOfBackups) {
  // filter out backups of the type we care about.
  var filteredFiles = files.filter(
    function f(v) { 
        return (v.name.indexOf(calName + "_", 0) != -1)
    });
  // Sort by lastmodifed
  filteredFiles.sort(
    function s(a,b) {
      return (a.lastmodified - b.lastmodified);
    });
  // And delete the oldest files, and keep the desired number of
  // old backups
  var i;
  var file;
  for (i = 0; i < filteredFiles.length - numOfBackups; ++i) {
    file = dir.clone();
    file.append(filteredFiles[i].name);

    // This can fail because of some crappy code in nsILocalFile.
    // That's not the end of the world.  We can try to remove the
    // file the next time around.
    try {
      file.remove(false);
    } catch(ex) {}
  }
  return;
}
  
function deleteOldBackups(dir, calName, numOfBackups) {
  // Enumerate files in the backupdir for expiry of old backups
  var backupDir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	backupDir.initWithPath(dir);
  var dirEnum = backupDir.directoryEntries;

  var files = [];
  while (dirEnum.hasMoreElements()) {
    var file = dirEnum.getNext().QueryInterface(Components.interfaces.nsIFile);
    if (file.isFile())
      files.push({name: file.leafName, lastmodified: file.lastModifiedTime});
  }
  purgeBackupsByType(files, calName, backupDir, numOfBackups);
  return;
}

function ae_startApp(mode){
  var path      = autoExportPrefs.getCharPref(mode + ".startApplication.appPath");
  var argumentstr = autoExportPrefs.getCharPref(mode + ".startApplication.appParams");
  
  var arguments = argumentstr.split(";");
  
  if (path == "") return false;
  
  var file    = Components.classes['@mozilla.org/file/local;1']
                .createInstance(Components.interfaces.nsILocalFile);
  var process = Components.classes['@mozilla.org/process/util;1']
                .getService(Components.interfaces.nsIProcess);
                
  file.initWithPath(path);

  if (!file.exists()) return false;
  
  if (!file.isExecutable()){
    file.launch();
    return true;
  }
  process.init(file);
  process.run(false, arguments, arguments.length);
  return true;
}

/******************************** Timer Export ********************************/

function ae_initMenupopup(mode){

  document.getElementById("ae.id." + mode + ".button.timer.activate").setAttribute("checked", String(autoExportPrefs.getBoolPref(mode + ".button.timer.activate")));
  document.getElementById("ae.id." + mode + ".button.timer.value1").setAttribute("checked", "false");
  document.getElementById("ae.id." + mode + ".button.timer.value2").setAttribute("checked", "false");
  document.getElementById("ae.id." + mode + ".button.timer.value3").setAttribute("checked", "false");
  document.getElementById("ae.id." + mode + ".button.timer.value4").setAttribute("checked", "false");
  document.getElementById("ae.id." + mode + ".button.timer.userdefined").setAttribute("checked", "false");
  
  var timertime = autoExportPrefs.getIntPref(mode + ".button.timer.radio.value");
 
  switch(timertime){
    case 15  : document.getElementById("ae.id." + mode + ".button.timer.value1").setAttribute("checked", "true"); break;
    case 30  : document.getElementById("ae.id." + mode + ".button.timer.value2").setAttribute("checked", "true"); break;
    case 60  : document.getElementById("ae.id." + mode + ".button.timer.value3").setAttribute("checked", "true"); break;
    case 120 : document.getElementById("ae.id." + mode + ".button.timer.value4").setAttribute("checked", "true"); break;
    default  : document.getElementById("ae.id." + mode + ".button.timer.userdefined").setAttribute("checked", "true");
  }
  
}

function ae_setUserdefinedTime(mode){
  if(mode == "normal")
    var param = {inn:{mode:"normal"}, out:null};
  else if(mode == "backup")
    var param = {inn:{mode:"backup"}, out:null};
  
  window.openDialog("chrome://autoExport/content/timerUserdefined.xul", "",
                      "chrome,centerscreen,modal", param);
  ae_setTime(mode, autoExportPrefs.getIntPref(mode + ".button.timer.radio.value"));
}

function initUserdefinedTime(){
  var mode = window.arguments[0].inn.mode;
  var timertime = autoExportPrefs.getIntPref(mode + ".button.timer.radio.value");
  var hour = String(timertime / 60);
  var hourarray = hour.split(".");
  var minute = String(timertime % 60);
  document.getElementById("ae.both.userdefined.hour").value = hourarray[0];
  document.getElementById("ae.both.userdefined.minute").value = minute;
}

function onAccept_Userdefined(){
  var mode = window.arguments[0].inn.mode;
  var timertime = (parseInt(document.getElementById("ae.both.userdefined.hour").value) * 60) + parseInt(document.getElementById("ae.both.userdefined.minute").value);
  autoExportPrefs.setIntPref(mode + ".button.timer.radio.value", timertime);
  return true;
}

function onCancel_Userdefined(){
  if (navigator.platform.charAt('Win')) return true;
  this.onAccept_Userdefined();
  return true;
}

function ae_setTime(mode, time){
  autoExportPrefs.setIntPref(mode + ".button.timer.radio.value", time);
  autoExportPrefs.setBoolPref(mode + ".button.timer.activate", true);
  ae_activateIntervall(mode);
}

function ae_onActivate(mode){
  var state = document.getElementById("ae.id." + mode + ".button.timer.activate").getAttribute("checked");
  if (state == "true")
    autoExportPrefs.setBoolPref(mode + ".button.timer.activate", true);
  else
    autoExportPrefs.setBoolPref(mode + ".button.timer.activate", false);
  
  ae_activateIntervall(mode);
}

function ae_activateIntervall(mode){
  if(mode == "normal" && timerActive_normal != 0){
    clearInterval(timerActive_normal);
    timerActive_normal = 0;
  }else if (mode == "backup" && timerActive_backup != 0){
    clearInterval(timerActive_backup);
    timerActive_backup = 0;
  }
  
  if (autoExportPrefs.getBoolPref(mode + ".button.timer.activate")){
    var intervall = autoExportPrefs.getIntPref(mode + ".button.timer.radio.value") * 60 * 1000;
    if(mode == "normal")
      timerActive_normal = setInterval("autoExport('normal')", intervall);
    else if (mode == "backup")
      timerActive_backup = setInterval("autoExport('backup')", intervall);
  }
}

function ae_initTimer(){
  ae_activateIntervall("normal");
  ae_activateIntervall("backup");
}

function ae_uninitTimer(){
  if(timerActive_normal != 0)
    clearInterval(timerActive_normal);
  if(timerActive_backup != 0)
    clearInterval(timerActive_backup);  
}