﻿var autoExportPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("ae.prefid.");



function cleanFromUnnecessarySemicolon(calendarNames){
	var newCalendarNames = calendarNames.replace(";;", ";");
	if(newCalendarNames.charAt(newCalendarNames.length - 1) == ";"){
		newCalendarNames = newCalendarNames.substring(0, newCalendarNames.length - 1);
	}
	return newCalendarNames;
}

function getPref(type, prefname){
  if(type == "bool"){
    try{
      return autoExportPrefs.getBoolPref(prefname);
    }catch(e){
      alert("AutoExport-Exception: " + e);
      dump("AutoExport-Exception: " + e);
    }
  }else if(type == "char"){
    try{
      return autoExportPrefs.getCharPref(prefname);
    }catch(e){
      alert("AutoExport-Exception: " + e);
      dump("AutoExport-Exception: " + e);
    }
  }else if(type == "int"){
    try{
      return autoExportPrefs.getIntPref(prefname);
    }catch(e){
      alert("AutoExport-Exception: " + e);
      dump("AutoExport-Exception: " + e);
    }
  }
  return null;
}
  
var autoExportSettings = {
	
	onLoad : function(mode) {
		document.getElementById("ae.id." + mode + ".exportFormat.csv").checked = false;
    document.getElementById("ae.id." + mode + ".exportFormat.csv").disabled = true;
    sizeToContent();
	},
  
 	onAccept : function() {
    return true;
	},
  
  onCancel : function() {
    return true;
  },
  	
	initControls : function(mode) {
    this.toggleAllCalendar(mode);
    this.toggleStartApp(mode);    
  },
	
  getCalendarToExport : function(mode) {			
		var localize = document.getElementById("ae.id.stringbundle");
		const PROMPTTEXT_CALENDAR = localize.getString('calendarDialogPrompttext');		
		function setCalendarToTextbox(calendarToExport) {
			var currentCalendars = document.getElementById("ae.prefid." + mode + ".exportCalendars.calendars").value;
			// is the textbox empty
			if (currentCalendars == ""){
				document.getElementById("ae.prefid." + mode + ".exportCalendars.calendars").value = calendarToExport.name;
        document.getElementById("ae.id." + mode + ".exportCalendars.calendars").value = calendarToExport.name;
			}else{
				// is the calendar always registered
				if(currentCalendars.indexOf(calendarToExport.name) == -1){
          document.getElementById("ae.prefid." + mode + ".exportCalendars.calendars").value = cleanFromUnnecessarySemicolon(currentCalendars) + ";" + calendarToExport.name;
					document.getElementById("ae.id." + mode + ".exportCalendars.calendars").value = cleanFromUnnecessarySemicolon(currentCalendars) + ";" + calendarToExport.name;
        }
      }
		}		
		var args = new Object();
		args.onOk = setCalendarToTextbox;
		args.promptText = PROMPTTEXT_CALENDAR;
		openDialog("chrome://calendar/content/chooseCalendarDialog.xul", 
							 "_blank", "chrome,titlebar,modal,resizable", args);				 
		return true;
	},
	
	removeCalendarToExport : function(mode) {			
		var localize = document.getElementById("ae.id.stringbundle");
		const PROMPTTEXT_CALENDAR = localize.getString('calendarDialogPrompttext');		
		function removeCalendarFromTextbox(calendarToExport) {
			var currentCalendars = document.getElementById("ae.prefid." + mode + ".exportCalendars.calendars").value;
			// is the textbox empty
			if (currentCalendars == "") return;
			else{
				// is the calendar always registered
				if(currentCalendars.indexOf(calendarToExport.name) != -1){
					var calendarName = calendarToExport.name;
					currentCalendars = currentCalendars.replace(calendarName, "");
          document.getElementById("ae.prefid." + mode + ".exportCalendars.calendars").value = cleanFromUnnecessarySemicolon(currentCalendars);
					document.getElementById("ae.id." + mode + ".exportCalendars.calendars").value = cleanFromUnnecessarySemicolon(currentCalendars);
				}
			}
		}
		var args = new Object();
		args.onOk = removeCalendarFromTextbox;
		args.promptText = PROMPTTEXT_CALENDAR;
		openDialog("chrome://calendar/content/chooseCalendarDialog.xul", 
							 "_blank", "chrome,titlebar,modal,resizable", args);				 
		return true;
	},
	
	getDirForExport : function(mode) {	 
		var localize = document.getElementById("ae.id.stringbundle");
		const PROMPTTEXT_DIRECTORY= localize.getString('directoryDialogPrompttext');
		const CURRENTDIRFOREXPORT = document.getElementById("ae.prefid." + mode + ".directory").value;
		var newDirForExport = null;
		// set current path as new beginning for searching
		if(CURRENTDIRFOREXPORT != ""){
			try{
        newDirForExport = Components.classes["@mozilla.org/file/local;1"]
                                    .createInstance(Components.interfaces.nsILocalFile);
        newDirForExport.initWithPath(CURRENTDIRFOREXPORT);
      }catch(e){
        newDirForExport = Components.classes['@mozilla.org/file/directory_service;1']
  																	.createInstance(Components.interfaces.nsIProperties)
  																	.get("CurProcD", Components.interfaces.nsIFile);
      }
		}
		// set the installation-directory as beginning for searching
		else{
			newDirForExport = Components.classes['@mozilla.org/file/directory_service;1']
																	.createInstance(Components.interfaces.nsIProperties)
																	.get("CurProcD", Components.interfaces.nsIFile);
		}
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);			
		fp.displayDirectory = newDirForExport; 
		fp.init(window, PROMPTTEXT_DIRECTORY, Components.interfaces.nsIFilePicker.modeGetFolder);
		fp.appendFilters(Components.interfaces.nsIFilePicker.filterAll);		  
		if (fp.show()==Components.interfaces.nsIFilePicker.returnOK) {
			newDirForExport = fp.file.QueryInterface(Components.interfaces.nsILocalFile);
			document.getElementById("ae.prefid." + mode + ".directory").value = newDirForExport.path;
      document.getElementById("ae.id." + mode + ".directory").value = newDirForExport.path; 
		}
	},
  
	toggleAllCalendar : function(mode){
		var chkbox = document.getElementById("ae.id." + mode + ".exportCalendars.allCalendars").checked;
		document.getElementById("ae.id." + mode + ".exportCalendars.calendars").disabled = chkbox;
		document.getElementById("ae.id." + mode + ".exportCalendars.getButton").disabled = chkbox;
		document.getElementById("ae.id." + mode + ".exportCalendars.removeButton").disabled = chkbox;
	},
  
  toggleStartApp : function(mode){
    var chkbox = document.getElementById("ae.id." + mode + ".startApplication.activate").checked;
		document.getElementById("ae.id." + mode + ".startApplication.appPath").disabled = !chkbox;
		document.getElementById("ae.id." + mode + ".startApplication.appParams").disabled = !chkbox;
  }
  
};

