
function loadAlarmOptions() {
		var alarmText = null;		
		var snoozeTime = null;		
		var alertGroup = document.getElementById('alertGroup');			
		var snoozeGroup = document.getElementById('snoozeGroup');	
		var alertButtonGroup = document.getElementById('alertButtonGroup');	
		
		var desc = document.getElementById("newAlarmText");
		// set alert time to first non-zero time 
		var alertTimesList = document.getElementById('reminderFox-alertTime');			
		var snoozeTimeList = document.getElementById('reminderFox-snoozeTime');	
		
		// if this is the quick alarm during alert...
		if ( window.arguments != null && window.arguments[0] != null ) {
			alarmText = window.arguments[0].alarmText;
			document.title = 	document.title + ": " + alarmText;
			desc.value = alarmText;
			snoozeTime = window.arguments[0].snoozeTime;
			
			var snoozeTimeInt = parseInt( snoozeTime );			
			var timeUnitsList = document.getElementById('reminderFox-snoozeTimeUnits');			
			if (  reminderFox_mod( snoozeTimeInt , (60 * 24) ) == 0 ) { 
				// days
				snoozeTimeList.label =( snoozeTimeInt / (60*24) );
				timeUnitsList.selectedIndex = 2;			
			}
			else if (  reminderFox_mod( snoozeTimeInt , 60 ) == 0 ) { 
				// hours
				snoozeTimeList.label = (snoozeTimeInt / 60);	
				timeUnitsList.selectedIndex = 1;
			}
			else {
				// minutes
				snoozeTimeList.label = snoozeTime;
				timeUnitsList.selectedIndex = 0;
			}
			
			alertGroup.setAttribute( "hidden", true);
			snoozeGroup.removeAttribute( "hidden");
			desc.setAttribute( "readonly", true);
			alertButtonGroup.setAttribute( "hidden", true ); 
			
			playAlarmSound();		
		}
		
		// otherwise, this is the initial window used for input
		else {
			snoozeGroup.setAttribute( "hidden", true);			
			alertGroup.removeAttribute( "hidden");
			desc.focus();
			calculateTargetTime();
		}					
				
		
}

function calculateTargetTime() {	
	var desc = document.getElementById("reminderFox-alertInfoTimeConversion");
	var alertTimesList = document.getElementById("reminderFox-alertTime");	
	var snoozeTime = alertTimesList.label;		
	
	if ( desc != null && reminderFox_isInteger( snoozeTime ) ) {
		var currentTime = new Date();

		var timeUnitsList = document.getElementById('reminderFox-alertTimeUnits');			
		if ( timeUnitsList != null ) { 
			var timeSelected = timeUnitsList.selectedIndex;
			if ( timeSelected == 1 ) {
				snoozeTime = snoozeTime * 60;
			}
			else if ( timeSelected == 2 ) {
				snoozeTime = snoozeTime * 60 * 24;
			}	
		}
	
		currentTime.setMinutes( currentTime.getMinutes() + parseInt( snoozeTime) );

		var timeString = getTimeString( currentTime );
		if ( timeString != null && timeString != "" ) {
			timeString = "(" +timeString  + ")";
			desc.setAttribute( "value", timeString );
		}
	}		
}

function getTimeString( date ) {
	var timeString;
	try {
			var hours = date.getHours();
			var AMorPM;
				
			var use24HourTime;
			try {
				use24HourTime = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_USE_24_HOUR_TIME);
			} catch(e) {
			}				
			if (  use24HourTime ) {
				AMorPM = "";
				if ( hours < 10 ) {
					hours = "0" + hours;
				}
			}
			else {
				AMorPM  =reminderFox_getBundle().getString("rf.add.time.PM");
				if ( AMorPM != "" ) {
					if ( hours < 12 ) {
						AMorPM = reminderFox_getBundle().getString("rf.add.time.AM");
					}
					if ( hours == 0 ) {
						hours = 12;
					}
					if ( hours >= 13 ) {
						hours = hours -12;
					}	
				}	
			}
		
			var minutes = date.getMinutes();
			if ( minutes < 10 ) {
				minutes = "0" + minutes;
			}
							
			timeString = hours + reminderFox_getBundle().getString("rf.add.time.delimiter") + minutes;
			if ( AMorPM != "" ) {
				timeString = timeString + " " + AMorPM;		
			}
		}
		catch ( e ) { 
		}
		return timeString;
}


function setAlarm() {
		var desc = document.getElementById("newAlarmText");
		var alertTimesList = document.getElementById("reminderFox-alertTime");	
		var snoozeTimeList = document.getElementById('reminderFox-snoozeTime');	
				
		var snoozeTime;
		var timeUnitsList;
		if ( window.arguments != null && window.arguments[0] != null ) {
			snoozeTime = snoozeTimeList.label;
			timeUnitsList = document.getElementById('reminderFox-snoozeTimeUnits');		
		}
		else {
			snoozeTime = alertTimesList.label;
			timeUnitsList = document.getElementById('reminderFox-alertTimeUnits');		
		}
		
		if ( reminderFox_isInteger( snoozeTime ) ) {						
			if ( timeUnitsList != null ) { 
				var timeSelected = timeUnitsList.selectedIndex;
				if ( timeSelected == 1 ) {
					snoozeTime = snoozeTime * 60;
				}
				else if ( timeSelected == 2 ) {
					snoozeTime = snoozeTime * 60 * 24;
				}	
			}					
			
			var windowEnumerator =  reminderFox_getWindowEnumerator();
			if (windowEnumerator.hasMoreElements()) {
				var oldestWindow = windowEnumerator.getNext();										
				oldestWindow.setTimeout('reminderFox_showQuickAlarm("'+desc.value+'","'+snoozeTime+'")', snoozeTime*60000);
									
				reminderFox_updateQuickAlarms( desc.value, snoozeTime );				
			}		
		}	
		
		close();						
}

function reminderFox_updateQuickAlarms( quickAlarmText, snoozeTime ) {	
	var currentTime = new Date().getTime();
	currentTime = currentTime + (snoozeTime*60000);
	var str = "X-REMINDERFOX-VALARM:" + quickAlarmText + "X-REMINDERFOX-SNOOZE:" + currentTime + ";PT"+ snoozeTime + "M";
	var quickAlarms = reminderFox_getUnicodePref(REMINDER_FOX_PREF + "." + REMINDER_FOX_QUICK_ALARMS);		
	if ( quickAlarms != null ) {
		var oldItem = quickAlarms.indexOf(quickAlarmText );
		if ( oldItem == -1 ) {
			// this alarm doesn't exist.  Write it to the end of the text
			quickAlarms = quickAlarms + str;
		}
		else { 
			// remove old version
			var oldIndex = quickAlarms.lastIndexOf("X-REMINDERFOX-VALARM:", oldItem );				
			var snoozeTimeIndex = quickAlarms.indexOf( ";PT", oldItem + quickAlarmText.length );
			if ( snoozeTimeIndex != -1 ) {					
				var snoozeEndIndex = quickAlarms.indexOf( "M", snoozeTimeIndex );
				if ( snoozeEndIndex != -1 ) {
					// write out new quick alarm
					quickAlarms = quickAlarms.substring( 0, oldIndex ) +
						str +
						quickAlarms.substring( snoozeEndIndex + 1);
				}
			}								
		}
	}	
	
	reminderFox_setUnicodePref( REMINDER_FOX_QUICK_ALARMS, quickAlarms);		
}

function reminderFox_removeQuickAlarm( quickAlarmText ) {	
	var quickAlarms = reminderFox_getUnicodePref(REMINDER_FOX_PREF + "." + REMINDER_FOX_QUICK_ALARMS);		
	if ( quickAlarms != null ) {
		var oldItem = quickAlarms.indexOf(quickAlarmText );
		if ( oldItem != -1 ) {
			// remove quick alarm
			var oldIndex = quickAlarms.lastIndexOf("X-REMINDERFOX-VALARM:", oldItem );				
			var snoozeTimeIndex = quickAlarms.indexOf( ";PT", oldItem + quickAlarmText.length );
			if ( snoozeTimeIndex != -1 ) {					
				var snoozeEndIndex = quickAlarms.indexOf( "M", snoozeTimeIndex );
				if ( snoozeEndIndex != -1 ) {
					// write out new quick alarm
					quickAlarms = quickAlarms.substring( 0, oldIndex ) +						
						quickAlarms.substring( snoozeEndIndex + 1);
				}
			}								
		}
	}	
	reminderFox_setUnicodePref( REMINDER_FOX_QUICK_ALARMS, quickAlarms);	
}

function playAlarmSound() {
	// play a sound for notification (if the user elects to)
	try {
		var playSound = true;
		try {
			playSound = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." +  REMINDER_FOX_ALARM_SOUND);
		}
		catch ( e) {
		}
		if ( playSound ) {
			reminderFox_playSound();
	  	} // end if		
	}
	catch ( e ) {
	}
}

function reminderFox_snoozeTimeChanged() {
	document.getElementById("snoozeButton").setAttribute( "default", true );
	document.getElementById("okButton").setAttribute( "default", false );
}

function reminderFox_closeAlarm() {	
	if ( window.arguments != null && window.arguments[0] != null ) {
		var alarmText = window.arguments[0].alarmText;	
		reminderFox_removeQuickAlarm( alarmText );
	}
	window.close();
}