/* Thanks to Sandesh Karalkar for the original datepicker widget code */

function oeDatePicker()  {
 }
 
/**
*   Static variables
*/

/** The popup window containing the picker */
 oeDatePicker.gPopup  = null;
 
 
/** The original starting date and currently selected date */
 oeDatePicker.gOriginalDate = null; 
 oeDatePicker.gSelectedDate = null; 
 
 /* selected items */
 oeDatePicker.gSelectedMonthItem = null;
 oeDatePicker.gSelectedDayItem = null;
 
 oeDatePicker.gTodaysDate = new Date();
 
 oeDatePicker.gStartingDayOfWeek = 0; // 0 for Sunday, 1 for Monday, etc
 
 oeDatePicker.isDatePicker = false;
 
/**
*   Set up the picker, called when the popup pops
*/
oeDatePicker.onpopupshowing = function( startDate, isDatePicker ) {
	if ( isDatePicker ) {
		oeDatePicker.isDatePicker = true;
	}
	
	try {
		oeDatePicker.gStartingDayOfWeek = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_CALENDAR_START_DAY);
	} catch(e) {
		oeDatePicker.gStartingDayOfWeek = REMINDER_FOX_CALENDAR_START_DAY_DEFAULT;
	}	
	
	// redraw dates if neccessary
	if ( oeDatePicker.gStartingDayOfWeek != 0 ) {
		for ( var i = 0; i < 7; i++ ) {
			var dayItem = document.getElementById( "calDay" + i  );
			var modifiedNumber = i + oeDatePicker.gStartingDayOfWeek;
			modifiedNumber = reminderFox_mod( modifiedNumber , 7);			
		     dayItem.setAttribute( "value", reminderFox_getBundle().getString("rf.options.day." + modifiedNumber + ".name.MMM"));
			// mark "Sunday" as Red
			var dayBox = document.getElementById( "oe-date-picker-month-day-" + (i+1) + "-header-box" );
			if ( modifiedNumber == 0 ) {
				dayBox.setAttribute( "class",  "oe-date-picker-month-days-header-class-red");
			}
			else {
				dayBox.setAttribute( "class",  "oe-date-picker-month-days-box-header-class");				
			}
		}
	}
	
   oeDatePicker.gOriginalDate = new Date( startDate );
   oeDatePicker.gSelectedDate = new Date( startDate );
   
   // draw the year based on the selected date   
   oeDatePicker.redrawYear();
   // draw the month based on the selected date   
   var month = oeDatePicker.gSelectedDate.getMonth() + 1;
   var selectedMonthBoxItem = document.getElementById( "oe-date-picker-year-month-" + month + "-box"  );
   oeDatePicker.selectMonthItem( selectedMonthBoxItem );
   
   // draw in the days for the selected date
   oeDatePicker.redrawDays();
}

 
/**
*   Called when a day is clicked, close the picker and call the client's oncommand
*/
oeDatePicker.clickDay = function( element, newDayItemNumber ) {
   // get the clicked day
   var dayNumberItem = document.getElementById( "oe-date-picker-month-day-text-" + newDayItemNumber );
   
   var dayNumber = dayNumberItem.getAttribute( "value" );
   
   // they may have clicked an unfilled day, if so ignore it and leave the picker up
   if( dayNumber != "" )  {
         // set the selected date to what they clicked on
         oeDatePicker.gSelectedDate.setDate( dayNumber );
		 oeDatePicker.redrawDays();
		if ( !oeDatePicker.isDatePicker ) {
			highlightReminderForDate( oeDatePicker.gSelectedDate.getMonth(), oeDatePicker.gSelectedDate.getDate()  );
		}
		else {
			var popup = reminderFox_findParentById( element, "oe-date-picker-popup", "oe-date-picker-popup-end" );
			popup.hidePopup();
		}
   }
   
	var displayListIndex = getDisplayIndex();
	var remindersTab = document.getElementById("remindersTab");
 	 if ( remindersTab != null  ) {   // ignore this if we are doing a popup from within the Event dialog
		// week
		 if ( displayListIndex == 2 ) {
		 	if ( isReminderTabSelected() ) {			
				displayTypeChanged();
		 	}
		 	else {
		 		displayTypeChangedTodo();
		 	}
			oeDatePicker.redrawDays();	
			return;
		}
		// day
		if ( displayListIndex == 3 ) {
			if ( isReminderTabSelected() ) {			
				displayTypeChanged();
		 	}
		 	else {
		 		displayTypeChangedTodo();
		 	}
			oeDatePicker.redrawDays();	
			return;
		}			
 	 }		
}


/**
* Called when a month box is clicked 
*/

oeDatePicker.clickMonth = function( newMonthItem, newMonthNumber ){
   // already selected, return
   if( oeDatePicker.gSelectedMonthItem  == newMonthItem )   {
      return;
   }
   
   // Avoid problems when changing months if the date is at the end of the month
   // i.e. if date is 31 march and you do a setmonth to april, the month would
   // actually be set to may, beacause april only has 30 days.
   // This is why we keep the original date around.
   var oldDate = oeDatePicker.gSelectedDate.getDate();
   var yearNumber = oeDatePicker.gSelectedDate.getFullYear();
   
   var lastDayOfMonth = oeDatePicker.getLastDayOfMonth( yearNumber, newMonthNumber-1 );

   if ( oldDate > lastDayOfMonth )  {
       oeDatePicker.gSelectedDate.setDate(lastDayOfMonth);
   }
   
   // update the selected date   
   oeDatePicker.gSelectedDate.setMonth( newMonthNumber - 1 );
   
   // select Month   
   oeDatePicker.selectMonthItem( newMonthItem );
 
   // redraw days
   oeDatePicker.redrawDays();
 
	var remindersTab = document.getElementById("remindersTab");
 	 if ( remindersTab != null  ) {   // ignore this if we are doing a popup from within the Event dialog
		var displayListIndex = getDisplayIndex();

		// month
		if ( displayListIndex == 1 ) {
			if ( isReminderTabSelected() ) {			
				displayTypeChanged();
		 	}
		 	else {
		 		displayTypeChangedTodo();
		 	}
			oeDatePicker.redrawDays();				
		}
		// week
		else if ( displayListIndex == 2 ) {
			if ( isReminderTabSelected() ) {			
				displayTypeChanged();
		 	}
		 	else {
		 		displayTypeChangedTodo();
		 	}
		    oeDatePicker.redrawDays();
			return;
		}
		// day
		if ( displayListIndex == 3 ) {
			if ( isReminderTabSelected() ) {			
				displayTypeChanged();
		 	}
		 	else {
		 		displayTypeChangedTodo();
		 	}
			oeDatePicker.redrawDays();
			return;
		}	
		
 	 }
	
}
 
oeDatePicker.getLastDayOfMonth = function( year, month  ) {
   var pastLastDate = new Date( year, month, 32 );
   var lastDayOfMonth = 32 - pastLastDate.getDate();
   
   return lastDayOfMonth;
}

/**
* Called when previous Year button is clicked 
*/

oeDatePicker.previousYearCommand = function() {
	if ( !oeDatePicker.isDatePicker ) {
		// reset the reminder array, so all reminders will be re-added in case the year-change affects
		// them (like <1978> style reminders)
		calendarReminderArray = null;
		calendarTodoArray = null;
	}
	
   // update the selected date
   var oldDate = oeDatePicker.gSelectedDate.getDate();
   var oldYear = oeDatePicker.gSelectedDate.getFullYear(); 
   var lastDayOfMonth = oeDatePicker.getLastDayOfMonth( (oldYear - 1), oeDatePicker.gSelectedDate.getMonth() );
	
	// handle leap year scenario (Feb. 29 is selected and then the year is changed)
   if ( oldDate > lastDayOfMonth )
   {
       oeDatePicker.gSelectedDate.setDate(lastDayOfMonth);
   }

   oeDatePicker.gSelectedDate.setFullYear( oldYear - 1 ); 
   
   	if ( !oeDatePicker.isDatePicker ) {
    	repopulateListForYear( oldYear, oeDatePicker.gSelectedDate.getFullYear() );
   	}
   // redraw the year and the days   
   oeDatePicker.redrawYear();   
   oeDatePicker.redrawDays();

	if ( !oeDatePicker.isDatePicker ) {
	   	selectCalendarSync = false;
		highlightClosestUpcomingReminder( oeDatePicker.gSelectedDate  );   
		selectCalendarSync = true;
	}
}


/**
* Called when next Year button is clicked 
*/

oeDatePicker.nextYearCommand = function() {
	if ( !oeDatePicker.isDatePicker ) {
		// reset the reminder array, so all reminders will be re-added in case the year-change affects
		// them (like <1978> style reminders)
		calendarReminderArray = null;
		calendarTodoArray = null;
	}
	
   // update the selected date
   var oldDate = oeDatePicker.gSelectedDate.getDate();
   var oldYear = oeDatePicker.gSelectedDate.getFullYear(); 
   var lastDayOfMonth = oeDatePicker.getLastDayOfMonth( (oldYear + 1), oeDatePicker.gSelectedDate.getMonth() );
	
	// handle leap year scenario (Feb. 29 is selected and then the year is changed)
   if ( oldDate > lastDayOfMonth )  {
       oeDatePicker.gSelectedDate.setDate(lastDayOfMonth);
   }   
   
   oeDatePicker.gSelectedDate.setFullYear( oldYear + 1 ); 
   
   	if ( !oeDatePicker.isDatePicker ) {
	   // redraw the year and the days
	   repopulateListForYear( oldYear , oeDatePicker.gSelectedDate.getFullYear() );
   	}
   
   oeDatePicker.redrawYear();
   oeDatePicker.redrawDays();
   
   	if ( !oeDatePicker.isDatePicker ) {
	   selectCalendarSync = false;
		highlightClosestUpcomingReminder( oeDatePicker.gSelectedDate  );    
		selectCalendarSync = true;
   	}
}
 

/**
* Draw the year based in the selected date 
*/

oeDatePicker.redrawYear = function() {
   var yearTitleItem = document.getElementById( "oe-date-picker-year-title-text" );
   yearTitleItem.setAttribute( "value", oeDatePicker.gSelectedDate.getFullYear() );
}


/**
* Select a month box 
*/

oeDatePicker.selectMonthItem = function( newMonthItem ) {
   // clear old selection, if there is one   
   
   if( oeDatePicker.gSelectedMonthItem != null )  { 
   		var id = oeDatePicker.gSelectedMonthItem.getAttribute( "id" ) ;
   		document.getElementById( id ).setAttribute( "selected" , false );  // set the poetenially cloned one as cleared
     	oeDatePicker.gSelectedMonthItem.setAttribute( "selected" , false );      
   }

   if ( newMonthItem != null ) { 
  		// Set the selected attribute, used to give it a different style   
    	newMonthItem.setAttribute( "selected" , true );
   }
      
   // Remember new selection  
  oeDatePicker.gSelectedMonthItem = newMonthItem;
}


/**
* Select a day box 
*/

oeDatePicker.selectDayItem = function( newDayItem ) {
   // clear old selection, if there is one   
   if( oeDatePicker.gSelectedDayItem != null )   {
   	  oeDatePicker.gSelectedDayItem.setAttribute( "selected" , false );
      oeDatePicker.gSelectedDayItem.setAttribute( "selectedReminder" , false );
   }

   if( newDayItem != null )   {
         // Set the selected attribute, used to give it a different style
   		var reminderDay =  newDayItem.getAttribute( "reminder" );
    	if ( reminderDay == "true" ) { 
    		newDayItem.setAttribute( "selectedReminder" , true );
    	}
    	else {
    	  newDayItem.setAttribute( "selected" , true );
    	  newDayItem.setAttribute( "selectedReminder" , false );
    	}
   }
         
   // Remember new selection      
   oeDatePicker.gSelectedDayItem = newDayItem;
}


/**
* Redraw day numbers based on the selected date
*/

oeDatePicker.redrawDays = function( ) {
	var dayNumberBoxItem;

   if ( oeDatePicker.gSelectedDate == null ) {
   	oeDatePicker.gSelectedDate = new Date();
   }
   // Write in all the day numbers
   var firstDate = new Date( oeDatePicker.gSelectedDate.getFullYear(), oeDatePicker.gSelectedDate.getMonth(), 1 );   
   var firstDayOfWeek = firstDate.getDay() - oeDatePicker.gStartingDayOfWeek;
   if ( firstDayOfWeek < 0 ) {
  	firstDayOfWeek =  firstDate.getDay() + (7 - oeDatePicker.gStartingDayOfWeek);
  }
  
   var lastDayOfMonth = oeDatePicker.getLastDayOfMonth( oeDatePicker.gSelectedDate.getFullYear(), oeDatePicker.gSelectedDate.getMonth() )
   var currentFirstDate = new Date( oeDatePicker.gTodaysDate.getFullYear(), oeDatePicker.gTodaysDate.getMonth(), 1 );
   var firstDayOfCurrentDateWeek = currentFirstDate.getDay()  - oeDatePicker.gStartingDayOfWeek;
   if ( firstDayOfCurrentDateWeek < 0 ) {
  	firstDayOfCurrentDateWeek =  currentFirstDate.getDay() + (7 - oeDatePicker.gStartingDayOfWeek);
  }
 
   // clear the selected day item   
   oeDatePicker.selectDayItem( null ); 
   // embolden today's date
  	if ( oeDatePicker.gTodaysDate.getMonth() == oeDatePicker.gSelectedDate.getMonth()  && 
   			oeDatePicker.gTodaysDate.getYear() == oeDatePicker.gSelectedDate.getYear()) {	
   		dayNumberBoxItem = document.getElementById( "oe-date-picker-month-day-" + (oeDatePicker.gTodaysDate.getDate() + firstDayOfCurrentDateWeek) + "-box"  );       		
	   	dayNumberBoxItem.setAttribute( "today" , true );
  	}
  	else {
   	    dayNumberBoxItem = document.getElementById( "oe-date-picker-month-day-" +(oeDatePicker.gTodaysDate.getDate() + firstDayOfCurrentDateWeek) + "-box"  );       		 	   	
   		dayNumberBoxItem.setAttribute( "today" , false );
   	}
 
   var monthArray = null;   
   var isReminder = true;
   var remindersTab = document.getElementById("remindersTab");
   if ( remindersTab != null  ) {   // ignore this if we are doing a popup from within the Event dialog
		if ( isReminderTabSelected() ) {			
		   if ( calendarReminderArray == null ) {	   		
		   		createCalendarReminderArray();	   				   		
		   	}
		   	monthArray = calendarReminderArray[oeDatePicker.gSelectedDate.getMonth()];
		}
		else {
			isReminder = false;
		   	if ( calendarTodoArray == null ) {
		   		createCalendarTodoArray();
		   	}
		   	 monthArray = calendarTodoArray[oeDatePicker.gSelectedDate.getMonth()];
		}
   }
	
   // redraw each day box in the 7 x 6 grid 
   var dayNumber = 1;
   	var multipleDayEvents = new Array();
   for( var dayIndex = 0; dayIndex < 42; ++dayIndex )  {
        // get the day text box
      	var dayNumberItem = document.getElementById( "oe-date-picker-month-day-text-" + (dayIndex + 1) );
        dayNumberBoxItem = document.getElementById( "oe-date-picker-month-day-" + (dayIndex + 1) + "-box" );
        
		// clear old styles and tooltips
        dayNumberBoxItem.setAttribute( "reminder" , false );
        dayNumberBoxItem.setAttribute( "completedReminder" , false );        
        dayNumberBoxItem.setAttribute( "important" , false );
        dayNumberBoxItem.setAttribute("tooltip", "");
        
      // if it is an unfilled day ( before first or after last ), just set its value to "",
   	  // and don't increment the day number.       
      if( dayIndex < firstDayOfWeek || dayNumber > lastDayOfMonth )  {
         dayNumberItem.setAttribute( "value" , "" );                
      }
      else {
		var important = false;
         // set the value to the day number         
         dayNumberItem.setAttribute( "value" , dayNumber );         
	
         if ( monthArray != null ) {
         	var reminderDaysArray = monthArray[dayNumber-1];
	 		 
	 		 // clear old tooltip
	 	   	 var tooltipItem = document.getElementById( "day-"+dayNumber  +"-tooltip");
		     while (tooltipItem.hasChildNodes()) {
		    	 tooltipItem.removeChild(tooltipItem.firstChild);
		  	 }
          	if ( reminderDaysArray != null ) {
				var reminderAdded = false;
				var completedReminderAdded = false;
				
         	   	for ( var  i = 0; i < reminderDaysArray.length; i++ ) {
					var 	reminder = reminderDaysArray[i];
					var completed = false;
					// don't add reminder to calendar widget if the event has been completed already
					if ( reminder.completedDate != null )  {
						if ( isReminder ) {
							var calendarDate = new Date(oeDatePicker.gSelectedDate.getFullYear(),oeDatePicker.gSelectedDate.getMonth(), dayNumber );
							// continue if marked complete
							if ( reminderFox_isCompletedForDate(reminder, calendarDate ) ) {					
								completed = true;							
							}
						}
						else {
							completed = true; // todo's should be shown as completed regardless of their date (as they have no multiple date occurrences)
						}
					}
	         		important = 	reminder.priority == REMINDER_PRIORITY_IMPORTANT;
	         		if ( important && !completed) {
	         		   	dayNumberBoxItem.setAttribute( "important" , true );
	         		 }	         	
	         		
					var reminderDescription = document.createElement("description");
					reminderDescription.setAttribute("value", reminder.summary);
					
					if ( completed ) {
						reminderDescription.setAttribute("style", " text-decoration: line-through;");
					}
					else if ( important ) {
						reminderDescription.setAttribute("style", "color: red;");
					}

					if ( completed ) {
						completedReminderAdded = true;
					}
					else {
						reminderAdded = true;
					}
					
					// check end dates
					var endDateAdded = false;
					if ( reminder.durationTime != null ) {
						if ( reminder.allDayEvent ) {
							if (reminder.durationTime >86400000 ) {   // 24 * 60 * 60 * 1000 = 1 day in ms
								//var reminderInstanceDate = new Date(oeDatePicker.gSelectedDate.getFullYear(),oeDatePicker.gSelectedDate.getMonth(), dayNumber );
								var reminderInstanceDate =reminder.date;
								var reminderInstanceEndDate = new Date(reminderInstanceDate.getTime() + reminder.durationTime);		
								reminderInstanceEndDate.setDate( reminderInstanceEndDate.getDate() - 1); // -1 enddate offset
								// set end date
								multipleDayEvents[multipleDayEvents.length] = { description: reminder.summary, isCompleted:  completed,  isImportant: important, endDate: reminderInstanceEndDate };
								endDateAdded = true;
							}
						}
						else {
							if ( reminder.durationTime > 60000 ) {
								var reminderInstanceDate =reminder.date;
								var reminderInstanceEndDate = new Date(reminderInstanceDate.getTime() + reminder.durationTime);	
								
								if (reminderInstanceEndDate.getMonth() == reminderInstanceDate.getMonth() &&
									reminderInstanceEndDate.getDate() == reminderInstanceDate.getDate() ) {
									// same days..  do nothing
								}
								// multiple days
								else { 
									// set end date
									multipleDayEvents[multipleDayEvents.length] = { description: reminder.summary, isCompleted:  completed,  isImportant: important, endDate: reminderInstanceEndDate };
									endDateAdded =true;
								}
							}
						}
					}
					
					if ( !endDateAdded ) {
						tooltipItem.appendChild(reminderDescription);
					}
     		    }
     		
     			if ( reminderAdded ) {
	     		   dayNumberBoxItem.setAttribute( "reminder" , true );
		           dayNumberBoxItem.setAttribute("tooltip", "day-"+dayNumber +"-tooltip");
     			}
     			else if ( completedReminderAdded ) {
     				dayNumberBoxItem.setAttribute( "completedReminder" , true );
		          	dayNumberBoxItem.setAttribute("tooltip", "day-"+dayNumber +"-tooltip");
     			}
	        }
	        
	           // check existing events
     		    if ( multipleDayEvents.length > 0 ) { 	 
     		    	var tooltipItem = document.getElementById( "day-"+dayNumber  +"-tooltip");
     		    	var calendarDate = new Date(oeDatePicker.gSelectedDate.getFullYear(),oeDatePicker.gSelectedDate.getMonth(), dayNumber );
	     		    for ( var e = 0; e < multipleDayEvents.length; e++ ) {
	     		    	if ( calendarDate.getMonth() < multipleDayEvents[e].endDate.getMonth() || 
	     		    		(calendarDate.getMonth() == multipleDayEvents[e].endDate.getMonth() && 
	     		    			calendarDate.getDate() <= multipleDayEvents[e].endDate.getDate()) ) {
				         		if ( multipleDayEvents[e].isImportant  && !multipleDayEvents[e].isCompleted ) {
				         		   	dayNumberBoxItem.setAttribute( "important" , true );
				         		 }	         	
				         		
								var reminderDescription = document.createElement("description");
								reminderDescription.setAttribute("value", multipleDayEvents[e].description );
								
								if (  multipleDayEvents[e].isCompleted  ) {
									reminderDescription.setAttribute("style", " text-decoration: line-through;");
								}
								else if (  multipleDayEvents[e].isImportant  ) {
									reminderDescription.setAttribute("style", "color: red;");
								}
								tooltipItem.appendChild(reminderDescription);
								if (  multipleDayEvents[e].isCompleted ) {
									dayNumberBoxItem.setAttribute( "completedReminder" , true );
						          	dayNumberBoxItem.setAttribute("tooltip", "day-"+dayNumber +"-tooltip");
								}
								else {
									dayNumberBoxItem.setAttribute( "reminder" , true );
						           dayNumberBoxItem.setAttribute("tooltip", "day-"+dayNumber +"-tooltip");
								}
	     		    	}
	     		    }
     		    }
	        
         }
         
         // draw the day as selected
         if( dayNumber == oeDatePicker.gSelectedDate.getDate() ) 
         {
            dayNumberBoxItem = document.getElementById( "oe-date-picker-month-day-" + (dayIndex + 1) + "-box"  );
            oeDatePicker.selectDayItem( dayNumberBoxItem );
         }
         
         // advance the day number         
         ++dayNumber;  
      }
   }
   	var multipleDayEvents = null;
 }

