// ++ IMPORTANT NOTICE --     
// 
// +++++++       This file is UTF-8. 
// +++++++       Please adjust you text editor prior to saving any changes!
//
// ++ IMPORTANT NOTICE --  
/*
 * //gW - Guenter Wahl ...    vers. 01. August 2007 15:03
 *
 *   add a Reminder for a selected 'Contact' of the TB / ADDRESSBOOK
 * ............................................................... 
 *
 
		The ABcard items added to the output (reminder.notes) are 
		configured with a 'rmFx_cardItems'-string 
		which is read from/written to the 'rmFx.abCardItems' TB-prefs.
		
		Valid items are all addressbook/card items, but only the following 
		have a 'locale' entry. For the others their item name is displayed.
		
			- LabelContact
				- DisplayName	
				- NickName
				- PrimaryEmail
				- SecondEmail
				- ScreenName
				
			- LabelHome
				- HomeAddress	
					
			- LabelWork
				- WorkAddress	
	
			- LabelPhone
				- CellularNumber	
				- FaxNumber			
				- PagerNumber
				
			- LabelOther
				- Costom1 .. 4
				

		'rmFx_cardItems'-string interpretation:

			!item				generates 'nameString' tab 'dataOfNameString'
			item				generates 'dataOfNameString' only
			item,[!]item		items separated with comma are generate an
								data output on same line separated by space								
			;					delimiter for generating a CR for the output
			//					an entry beginning with // is treated as comment 
								which is not written to the output
					
			- Items containing a substring of 'Label' are interpreted as header lines.	
			
			- Items with a leading 'X' are skipped for output.
			  This is a easy way to skip them, but hold them at the 
			  standard place in the default 'rmFx_cardItems'-String.	

			- The 'Category' items need not to be added to the
			  interpretation string, it's added to rmFx-field 'Categories'

			- 'Custom1..4'-item labels
				With the extension "MoreColsForAddressBook"
					https://nic-nac-project.org/~kaosmos/morecols-en.html
				installed, the 'labels' can be set individually and are 
				stored in the prefs.js parameters  
				"morecols.custom"+num+".label"  (num= 1...4)
				Those settings are read if xpi is installed.
		*/
	var rmFx_ABprop = "rf.contacts.";
	var rmFx_ABerrMsg = "addContact2Reminder Error!\n\nConfiguration item not valid:";
	
 	var rmFx_cardItems;		// this contain the active cardItem set

	var rmFx_cardItems0 = "// US version;"
					+ "LabelContact;"
						+ "!DisplayName;"
						+ "X!LastName,XFirstName;"
						+ "!PrimaryEmail,XSecondEmail;"
			
					+ "LabelPhone;"					
						+ "!HomePhone,!FaxNumber;"
						+ "!WorkPhone;"
						+ "!CellularNumber;"
					
					+ "LabelHome;"	
						+ "HomeAddress,HomeAddress2;"
						+ "HomeCity,HomeState,HomeZipCode;"			
						+ "HomeCountry;"				
			
					+ "LabelWork;"	
						+ "JobTitle;"
						+ "Company,Department;"
						+ "WorkAddress,WorkAddress2;"
						+ "WorkCity,WorkState,WorkZipCode;"			
						+ "WorkCountry;"				
			
					+ "LabelOther;"	
						+ "!Custom1,!Custom2;"
						+ "!Custom3;!Custom4;"
					//	+ "!AnniversaryYear,AnniversaryMonth,AnniversaryDay;"
						+ "X!BirthYear,XBirthMonth,XBirthDay;"
					
					;  // semikolon terminates 'rmFx_cardItems' !


	var rmFx_cardItemsEu = "// European version;"
					+ "LabelContact;"
						+ "!DisplayName;"
						+ "!LastName,FirstName;"
						+ "!PrimaryEmail,SecondEmail;"
			
					+ "LabelPhone;"					
						+ "!HomePhone,!FaxNumber;"
						+ "!WorkPhone;"
						+ "!CellularNumber;"
					
					+ "LabelHome;"	
						+ "!HomeAddress,HomeAddress2;"
						+ "!HomeZipCode,HomeCity;"			
						+ "!HomeCountry,!HomeState;"				
			
					+ "LabelWork;"	
						+ "JobTitle;"
						+ "!Company,Department;"
						+ "!WorkAddress,WorkAddress2;"
						+ "!WorkCity,WorkZipCode;"			
						+ "!WorkCountry,!WorkState;"				
			
					+ "LabelOther;"	
						+ "!Custom1,!Custom2;"
						+ "!Custom3;!Custom4;"
					//	+ "!AnniversaryYear,AnniversaryMonth,AnniversaryDay;"
						+ "X!BirthYear,XBirthMonth,XBirthDay;"
					
					;  // semikolon terminates 'rmFx_cardItems' !

	var rmFx_personalABURI = 'moz-abmdbdirectory://abook.mab';
	var rmFx_collectedAABURI = 'moz-abmdbdirectory://history.mab';
	var rmFx_selectedABURI = null;
	var rmFx_cDirectory = '';
	var rmFx_cCard;
	     
function reminderFox_addReminder4Contact(op){

	//	--- get the Contact info
	rmFx_selectedABURI = GetSelectedDirectory();
	rmFx_cDirectory = GetDirectoryFromURI(rmFx_selectedABURI).dirName;

	if (rmFx_cDirectory.isMailList)  { return;} // terminate if on 'List'		

	switch (op) {
	case "Reminder":  { // this is to set a reminder for a card 
		var rmFx_cCard = GetSelectedCard();	

		// --- setup the reminder -----
        var time = new Date();
        time.getTime();
        var timeString = reminderFox_mail_getTimeString( time );

        var dateVariableString;
        try { dateVariableString = reminderFox_getUnicodePref(REMINDER_FOX_PREF + "." + REMINDER_FOX_LIST_DATE_LABEL);
        	} catch(e) {}           
        var remFoxDate =reminderFox_getDateVariable( null, time, dateVariableString ) + "  " + timeString;
        
		var newDate = new Date();
		newDate.setDate( newDate.getDate() + 1 );  // default to using tomorrow's date for reminder
	
		var reminderId = rmFx_selectedABURI  
			+ "://" + rmFx_cDirectory + "//:" 
			+ reminderFox_generateUniqueReminderId( newDate );

		var remFoxSummary  = "[" + rmFx_itemName ("LabelContact") + "] " 
				+ rmFx_cCard.displayName;
				
		var	newReminderToBeAdded 	= new ReminderFoxEvent( reminderId, newDate, remFoxSummary );

		cNotes = '>' + rmFx_cDirectory  +  '<\n';

		var custItems ="";
		var labelStr = "";
		
		// +++++ read  all card-items to be added +++++
		if ( rmFx_readABcardPref() == -1) {rmFx_cardItems = rmFx_cardItems0;}	/* -- get default values  -- */								 

		cardItems = rmFx_cardItems.split(";");
		
		for (var i=0;i<cardItems.length;i++) { 

			var anyValue = false;	
			var currentLine = cardItems[i]; 
			
			if (cardItems[i].indexOf( "Label" ) != -1 ) {
				if (cardItems[i].charAt(0) != "X") {
					
					labelStr =  "\n" + rmFx_itemName (cardItems[i])
							+ ":\n";
				}
			} else {
				if ((currentLine != "") 
				  && (currentLine.substring(0,2) != "//")) {
				  
				  	var usAdr= false;
				  	if (	currentLine.indexOf("WorkCity,WorkState") != -1  ||
				  	 		currentLine.indexOf("HomeCity,HomeState") != -1  
				  		) usAdr = true;
				  
					var cItems = currentLine.split(",");  
					
					for (var j=0; j<cItems.length; j++) { /* one item */
						var namString = cItems[j]; 
				
						//  process  cardItem 
						if (namString.charAt(0) == "!") {
							// this needs to fetch the namString
							var iName = namString.substring(1);
						} else {iName = namString;} 
						
						if (iName == "HomeWebPage") iName ="WebPage1";
						if (iName == "WorkWebPage") iName ="WebPage2";
						var iname = iName.substring(0,1).toLowerCase() + iName.substring(1);

						if (iname.charAt(0) != "x") {
							var thisItem = rmFx_cCardItem(rmFx_cCard, iname);
							
							if (iName.indexOf("Custom") != -1) {
								if ( thisItem != -1 && thisItem != "") {
									cNotes +=  labelStr + "    " + rmFx_itemName(iName) + " : " 
														+ thisItem + "; "
									anyValue = true;
									labelStr = "";
								}
							} else {
								if (namString.charAt(0) == "!") {
									if ( thisItem != -1 && thisItem != "") {								
										cNotes += labelStr + "    " + rmFx_itemName(iName) + ":\t";
										anyValue = true;
										labelStr = "";
									}
								}		
								if ( thisItem != -1 && thisItem != "")  {
									if (labelStr != "" && thisItem != "") {
										cNotes += labelStr;
										labelStr = "";
									}
									if (anyValue == false) 	cNotes +=  "    ";								
									
									cNotes +=  thisItem ; 
									if (usAdr == false) { cNotes +=  "   ";}
										else {  cNotes +=  ",  "; 
									} usAdr = false;
									anyValue = true;
								}
							} 
						}
					}
				}
				if (anyValue == true) cNotes += "\n";
			}
		}	

		newReminderToBeAdded.notes = cNotes;	
		if (custItems != "") newReminderToBeAdded.notes  += "\n" + custItems + "\n";	

		// --- add ABcard-items to rmFx-fields ---
		
		// add address to 'Location' for search with Google Maps  
			var workAddr ="";
			if (!!rmFx_cCard.workAddress)	workAddr += rmFx_cCard.workAddress + " ";
			if (!!rmFx_cCard.workAddress2) 	workAddr += rmFx_cCard.workAddress2 + " ";
			if (!!rmFx_cCard.workCity)		workAddr += rmFx_cCard.workCity + " ";
			if (!!rmFx_cCard.workState)		workAddr += rmFx_cCard.workState + " ";
			if (!!rmFx_cCard.workZipCode)	workAddr += rmFx_cCard.workZipCode + " ";
			if (!!rmFx_cCard.workCountry)	workAddr += rmFx_cCard.workCountry + " ";
			
			var locAddr ="";
			if (!!rmFx_cCard.homeAddress)	locAddr += rmFx_cCard.homeAddress + " ";
			if (!!rmFx_cCard.homeAddress2) 	locAddr += rmFx_cCard.homeAddress2 + " ";
			if (!!rmFx_cCard.homeCity)		locAddr += rmFx_cCard.homeCity + " ";
			if (!!rmFx_cCard.homeState)		locAddr += rmFx_cCard.homeState + " ";
			if (!!rmFx_cCard.homeZipCode)	locAddr += rmFx_cCard.homeZipCode + " ";
			if (!!rmFx_cCard.homeCountry)    locAddr += rmFx_cCard.homeCountry + " ";
			

			if (locAddr == null || locAddr == "") locAddr = workAddr;
	//gW  .location does NOT accept local chars like Ã in 'KÃLN'  ==> so normalize the string
			newReminderToBeAdded.location = rmFx_normalizeNameString(locAddr);
		
		cItem = rmFx_cCard.primaryEmail;
		if (cItem != "") newReminderToBeAdded.url = "mailto" + ":" + cItem ;	

		cItem = rmFx_cCard.category;		
		if (cItem != "") newReminderToBeAdded.categories =  rmFx_cCard.category; 

/*		if (rmFx_cCard["birthYear"] != "")  {
			newReminderToBeAdded.summary += '   <' + rmFx_cCard["birthYear"] + '>';
		}
*/
		//  .... and go to display it ....
		var added = reminderFox_addReminderHeadlessly( newReminderToBeAdded );		
	
		rmFx_writeABcardPref();
	}
	case "Copy": {  // copy mailadr of selected cards to clipboard
			//    with mailName <mailadr@xxx.yy>, etc
		var rmFx_Cards = GetSelectedAbCards();
		var xAttendees="";
		for (var n=0; n < rmFx_Cards.length; n++) {
			xAttendees += rmFx_Cards[n].lastName + rmFx_Cards[n].firstName
			+ "<" + rmFx_Cards[n].primaryEmail + ">,";
		}
		// del last comma	
		xAttendees = xAttendees.substring(0,xAttendees.length-1)	
		rmFxAbookMini();  
		copytoClipboard(xAttendees);
		rmFxInsertAttendees(xAttendees);
		
		return;
		}	
	} // switch
}

function copytoClipboard(data) {
//-----------------------------------------------
	// Generic function to copy the data to Clipboard 
	var clipboard = Components.classes["@mozilla.org/widget/clipboardhelper;1"];
	clipboard = clipboard.getService(Components.interfaces.nsIClipboardHelper);
	clipboard.copyString(data );
}

function rmFx_cCardItem(rmFx_cCard,iname) {
/* ---------------- get item Value or set to -1 if invalid 
*/		
try {	!rmFx_cCard[iname].length;
		return rmFx_cCard[iname]; }	
		
	catch(ex) {
		alert(  rmFx_ABerrMsg + "\n" + iname); 				
		reminderFox_logMessageLevel(rmFx_ABerrMsg + iname, 2);
		return -1;
	}						
}



function rmFx_itemName (namItem) {
/* ---------- access the properties ... if relevant  -------------
*/
try {
	// .... access 'address.properties'	
	if (  namItem == "DisplayName" ||
		  namItem == "NickName"	   ||
		  namItem == "PrimaryEmail"||
		  namItem == "SecondEmail" ||
		  namItem == "ScreenName"    	) 
		return document.getElementById("bundle_addressBook").getString("property"+namItem); 		  	  

	// ...  access reminderfox.properties special for contacts 		  
	if (  namItem == "LabelContact" || 
		  namItem == "HomeAddress" 		)  	
		return reminderFox_getBundle().getString(rmFx_ABprop+namItem);
	  
	if (  namItem.indexOf("Label") != -1) 	
		return document.getElementById("bundle_addressBook")
			.getString("heading"+ namItem.substring(5)); 

	if (  namItem.indexOf("Number") != -1) 	
		return document.getElementById("bundle_addressBook")
			.getString("property"+ namItem.substring(0,namItem.indexOf("N"))); 


	// ... access morecols.properties  ... if there else addressbook.p
	if (  namItem.indexOf("Custom") != -1)
		return rmFx_getCustomLabel (namItem);

	// ... now no entries ... need to set it here (without 'locale' translation)
	if (  namItem.indexOf("Name") != -1 )	return namItem;

	if (  namItem == "JobTitle"			)	return "Job";
	if (  namItem == "Department"		)	return "Department";
	if (  namItem == "Company"			)	return "Company";
			  
	if (  namItem == "HomeWebPage" || 
		  namItem == "WorkWebPage"		)	return "WebPage";
	
	if (  namItem.indexOf("Address2") != -1) return "";

	//  ... delete 'Phone'  from item-name and return it 
	if (	namItem.indexOf("Phone") != -1)
		return namItem.substring(0,4); 

	// ... delete 'Work' or 'Home' from item-name and return it  
	if (	(namItem.indexOf("Work") != -1)
		||  (namItem.indexOf("Home") != -1) )
		return namItem.substring(4); 
	
	}
	catch(ex) {
		alert(  rmFx_ABerrMsg + "\n" + namItem); 				
		reminderFox_logMessageLevel(rmFx_ABerrMsg + namItem, 2);
	}					
	return namItem;
}



function rmFx_getCustomLabel (iName) {
/* ---------- work with Custom 1..4 individual entries  -------------
*/
	var cLabel="";
	var moreColsPrefs = Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefBranch);
			
	var cLabelid = 	"morecols." 
				+ iName.substring(0,1).toLowerCase() + iName.substring(1)+".label";	
	try { cLabel = moreColsPrefs.getComplexValue
			(cLabelid, Components.interfaces.nsISupportsString).data;
   		} catch(e) { cLabel = "Custom " + iName.substring(6,7); }
   		
   	return cLabel;
}

function rmFx_readABcardPref() {
/* ------------------------------------------------ READ  PREFS
*/
	var prefService = Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefBranch);
			
	var rmFxabCardPref = 	"rmFx.abCardItems";	
	try { rmFx_cardItems = prefService.getComplexValue
			(rmFxabCardPref, Components.interfaces.nsISupportsString).data;
	   	} catch(e) {return -1;}
   	return 0;
}

function rmFx_writeABcardPref() {
/* ------------------------------------------------ WRITE  PREFS
*/
	var prefService = Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefBranch);
			
	var rmFxabCardPref = 	"rmFx.abCardItems";	
	prefService.setCharPref(rmFxabCardPref, rmFx_cardItems);
}





// -----   this part still under development --------- 

function rmFx_callABcontact(event) {

	if (event.currentTarget.id == "treechildren-contextmenu-callContact") {
	/* Reminders selected 
	*/
		var multipleRemindersSelected = false;
		selectedReminders = getAllSelectedReminders();
		if ( selectedReminders.length > 1 ) { 
			multipleRemindersSelected = true;
		}
	 var _Notes = selectedReminders[0].notes;		
	} 
}

	
	/**  imported from "Duplicate Contact Manager" by   Marian Steinbach, 2006   
	 * normalizeNameString
	 *
	 * Strips some characters from a name so that different spellings (e.g. with and
	 * without accents, can be compared. Works case insensitive.
	 *
	 * @param	String		the string to be normalized
	 * @return	String		normalized version of the string
	 */
function rmFx_normalizeNameString(str) {
		// remove punctiation
		//str = str.replace(/[\"\-\_\'\.\:\,\;\&\+]+/g, '');
		
		// replace funny letters
		str = str.replace(/[ÃÃÃÃÃ¨Ã©ÃªÃ«ÄÄÄÄÄÄÄÄÄÄ]/g, 'e');
		str = str.replace(/[ÃÃÃÃÃÃ¢Ã¡Ã Ã£Ã¥ÄÄÄÄÄÄÇºÇ»]/g, 'a');
		str = str.replace(/[ÃÃÃÃÃ¬Ã­Ã®Ã¯Ä¨Ä©ÄªÄ«Ä¬Ä­Ä®Ä¯Ä°Ä±]/g, 'i');
		str = str.replace(/[ÃÃÃÃÃÃ²Ã³Ã´ÃµÃ¸ÅÅÅÅÅÅÇ¾Ç¿]/g, 'o');
		str = str.replace(/[ÃÃÃÃ¹ÃºÃ»Å¨Å©ÅªÅ«Å¬Å­Å®Å¯Å°Å±Å²Å³Æ¡Æ¯Æ°]/g, 'u');
		str = str.replace(/[ÃÃ½Ã¿Å¶Å·Å¸]/g, 'y');
		
		str = str.replace(/[ÃÃ§ÄÄÄÄÄÄÄÄ]/g, 'c');
		str = str.replace(/[ÃÃ°ÄÄÄ]/g, 'd');
		str = str.replace(/[ÄÄÄÄÄ Ä¡Ä¢Ä£]/g, 'g');
		str = str.replace(/[Ä¤Ä¥Ä¦Ä§]/g, 'h');
		str = str.replace(/[Ä´Äµ]/g, 'j');
		str = str.replace(/[Ä¶Ä·Ä¸]/g, 'k');
		str = str.replace(/[Ä¹ÄºÄ»Ä¼Ä¿ÅÅÅ]/g, 'l');
		str = str.replace(/[ÃÃ±ÅÅÅÅÅÅÅÅÅ]/g, 'n');
		str = str.replace(/[ÅÅÅÅÅÅ]/g, 'r');
		str = str.replace(/[ÅÅÅÅÅÅÅ Å¡]/g, 's');
		str = str.replace(/[Å¢Å£Å¤Å¥Å¦Å§]/g, 't');
		str = str.replace(/[Å´Åµ]/g, 'w');
		str = str.replace(/[Å¹ÅºÅ»Å¼Å½Å¾]/g, 'z');
		
		// replace ligatures
		str = str.replace(/[ÃÃÃ¤Ã¦Ç¼Ç½]/g, 'ae');
		str = str.replace(/[ÃÃ¶ÅÅ]/g, 'oe');
		str = str.replace(/[ÃÃ¼]/g, 'ue');
		str = str.replace(/[Ã]/g, 'ss');
		str = str.replace(/[Ä²Ä³]/g, 'ij');
		
		// remove single letters (like initials)
	/*	str = str.replace(/ [A-Za-z0-9] /g, ' ');
		str = str.replace(/^[A-Za-z0-9] /g, '');
		str = str.replace(/ [A-Za-z0-9]$/g, '');
	*/	
		// remove multiple white spaces
		str = str.replace(/[\s]{2,}/, ' ');
		
		// remove leading and trailing space
		str = str.replace(/[\s]{2,}/g, ' ');
		str = str.replace(/^[\s]+/, '');
		str = str.replace(/[\s]+$/, '');
		
		str = str.toLowerCase();
		return str;
	}
	
