const REMINDERFOX_PASSWORD_CID = "@mozilla.org/passwordmanager;1";

var gReminderFox_PasswordManager;
var gReminderFox_PasswordManagerInternal;

function reminderFox_getPasswordManager() {
  if (!gReminderFox_PasswordManager) {
    try {
      gReminderFox_PasswordManager = Components.classes[REMINDERFOX_PASSWORD_CID].getService();
      gReminderFox_PasswordManager = gReminderFox_PasswordManager.QueryInterface(
        Components.interfaces.nsIPasswordManager);
    } catch (e) {
      reminderFox_logMessageLevel("reminderFox_getPasswordManager() failed: " + e.name  +  " -- " + e.message, REMINDER_FOX_LOG_LEVEL_INFO);
      
    }
  }
  return gReminderFox_PasswordManager;
}

function reminderFox_getPasswordManagerInternal() {
  if (!gReminderFox_PasswordManagerInternal) {
    try {
      gReminderFox_PasswordManagerInternal =
        Components.classes[REMINDERFOX_PASSWORD_CID].getService();
      gReminderFox_PasswordManagerInternal = gReminderFox_PasswordManagerInternal.QueryInterface(
        Components.interfaces.nsIPasswordManagerInternal);
    } catch (e) {
         reminderFox_logMessageLevel("reminderFox_getPasswordManagerInternal() failed: " + e.name  +  " -- " + e.message, REMINDER_FOX_LOG_LEVEL_INFO);
    }
  }

  return gReminderFox_PasswordManagerInternal;
}

function reminderFox_getPassword(loginData) {
  if (!loginData) {
    return null;
   }

  var pmInternal = reminderFox_getPasswordManagerInternal();
  if (!pmInternal) {
    return null;
   }

  var host = {value:''};
  var user = {value:''};
  var password = {value:''};

  try {
    pmInternal.findPasswordEntry(loginData.ljURL, '', '',
      host, user, password);
    loginData.username = user.value;
    loginData.password = password.value;
    return loginData;
  } catch(e) {
        reminderFox_logMessageLevel("findPasswordEntry() failed: " + e.name  +  " -- " + e.message, REMINDER_FOX_LOG_LEVEL_INFO);
  }
  return null;
}

function reminderFox_savePassword(loginData) {
  if (!loginData || !loginData.ljURL || !loginData.username)
    return false;

  var pm = reminderFox_getPasswordManager();

  if (!pm)
    return false;

  try {
    pm.removeUser(loginData.ljURL, loginData.username);
  } catch(e) {
  	 reminderFox_logMessageLevel("removeUser() failed: " + e.name  +  " -- " + e.message, REMINDER_FOX_LOG_LEVEL_INFO);
  }

  if (loginData.savePassword) {
    try {
      pm.addUser(loginData.ljURL, loginData.username, loginData.password);
    } catch(e) {
    	 reminderFox_logMessageLevel("addUser failed: " + e.name  +  " -- " + e.message, REMINDER_FOX_LOG_LEVEL_INFO);
    }


    return true;
  }
  
  return false;
}

/*
  var loginData = {
    ljURL : getPref().CopyCharPref(LJ_URL_PREF),
    username : '',
    password : ''
  };
 */
