var Database;
var SmExporter = {
	sExpType: "txt",
	sObjectName: null,
	
	sData: null,
	lines : [],
	msLeafName: null,
	
	loadExportDialog: function ()
	{
		Database = window.arguments[0];
		var sObjectType = window.arguments[1];
		if (sObjectType == "import")
		{
			var dlg = document.getElementById("dialog-exim");
			document.title = "Import Data";
			dlg.setAttribute("ondialogaccept", "return SmExporter.doOKImport();");
			document.getElementById("hb-object-selection").hidden = true;
			return;
		}

		this.sObjectName = window.arguments[2];

		document.title = "Export the " + sObjectType + ": " + this.sObjectName;
		document.getElementById("lbl-objectnames").value = "Name of the " + sObjectType;
		var listbox = document.getElementById("ml-objectnames");
		var aObjectNames = Database.getObjectList(sObjectType);
		PopulateDropDownItems(aObjectNames, listbox, this.sObjectName);
	},
	
	onSelectObject: function()
	{
		var sObjectType = window.arguments[1];
		this.sObjectName = document.getElementById("ml-objectnames").value;

		document.title = "Export the " + sObjectType + ": " + this.sObjectName;
	},

	onSelectTab: function()
	{
		var oSelectedTab = document.getElementById("tabs-export").selectedItem;
		var sTabId = oSelectedTab.getAttribute("id");
		switch(sTabId)
		{
			case "tab-exp-csv":
				this.sExpType = "csv";
				break;
			case "tab-exp-sql":
				this.sExpType = "sql";
				break;
			case "tab-exp-xml":
				this.sExpType = "xml";
				break;
		}
	},

	doOKExport: function()
	{
		var oSelectedTab = document.getElementById("tabs-export").selectedItem;
		if(oSelectedTab.getAttribute("id") == "tab-exp-sql")
		{
		  alert("Not yet implemented.");
			return false;
		}

		var sTableName = document.getElementById("ml-objectnames").value;

		// get export file
		const nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"]
			      .createInstance(nsIFilePicker);
		fp.init(window, "Export to file ", nsIFilePicker.modeSave);
		fp.appendFilters(nsIFilePicker.filterAll);
		fp.defaultString = sTableName + "." + this.sExpType;
		
		var rv = fp.show();
		
		//if chosen then
		if (rv != nsIFilePicker.returnOK && rv != nsIFilePicker.returnReplace)
		{
			alert("Please choose a file to save the exported data to.");
			return false;
		}
		var file = Components.classes["@mozilla.org/file/local;1"]
							.createInstance(Components.interfaces.nsILocalFile);
		file.initWithFile(fp.file);

		var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
		
		// use 0x02 | 0x10 to open file for appending.
		foStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
		var sQuery = "SELECT * FROM `" + sTableName + "`";
		var iExportNum = 0;
		switch(this.sExpType)
		{
			case "csv":
				iExportNum = this.writeCsvContent(foStream, sQuery);
				break;
			case "sql":
				iExportNum = this.writeSqlContent(foStream, sQuery);
				break;
			case "xml":
				iExportNum = this.writeXmlContent(foStream, sQuery);
				break;
		}
		foStream.close();
		sm_message(iExportNum + " records exported to " + fp.file.path, 0x3);
		return false;
	},

	writeCsvContent: function(foStream, sQuery)
	{
		var cSeparator = document.getElementById("csv-separator").value;
		if(cSeparator == "other")
		  cSeparator = document.getElementById("csv-separator-text").value;

		var cEncloser = document.getElementById("csv-encloser").value;
		if(cEncloser == "other")
		 cEncloser = document.getElementById("csv-encloser-text").value;

		Database.selectQuery(sQuery);
		var allRecords = Database.getRecords();
		var columns = Database.getColumns();
		
		var bColNames = document.getElementById("csv-column-names").checked;
		if(bColNames)
		{
			var data = "";
			var i = 0;
			for(var i in columns)
			{
				if (i > 0) data += cSeparator;
				if (cEncloser == "din")
				{
          if (columns[i][0].indexOf('"') >= 0 || columns[i][0].indexOf(cSeparator) >= 0)
          {
            columns[i][0] = columns[i][0].replace("\"", "\"\"", "g");				
            data += '"' + columns[i][0] + '"';
          }
          else
            data += columns[i][0];
				}
				else
        	data += cEncloser + columns[i][0] + cEncloser;
				i++;
			}
			data += "\n";
			foStream.write(data, data.length);
		}

		for(var i = 0; i < allRecords.length; i++)
		{
			var row = allRecords[i];
			var data = "";
      for (var iCol = 0; iCol < row.length; iCol++) 
			{
				if (iCol > 0) data += cSeparator;
				if (cEncloser == "din")
				{
				  if(typeof row[iCol] == "string")
				  {
            if (row[iCol].indexOf('"') >= 0 || row[iCol].indexOf(cSeparator) >= 0)
            {
              row[iCol] = row[iCol].replace("\"", "\"\"", "g");				
              data += '"' + row[iCol] + '"';
            }
            else
              data += row[iCol];
          }
          else
            data += row[iCol];
				}
				else
    			data += cEncloser + row[iCol] + cEncloser;
      }
			data += "\n";
			foStream.write(data, data.length);
		}
		return allRecords.length;
	},

	writeSqlContent: function(foStream, sQuery)
	{
	},

	writeXmlContent: function(foStream, sQuery)
	{
		var bType = document.getElementById("xml-type-attribute").checked;

		Database.selectQuery(sQuery);
		var allRecords = Database.getRecords();
		var columns = Database.getColumns();
		var types = Database.getRecordTypes();
		var sDbName = Database.getFileName();
		var data = "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n";
		data += "<!--\n";
//		data += " version " + g_ExtVersion + "\n";
		data += "  GUID:  SQLiteManager@mrinalkant.blogspot.com\n";
		data += "  Homepage:  http://sqlite-manager.googlecode.com\n\n";
		var d = new Date();
		data += "  Generation Time: " + d.toGMTString() + "\n";
		data += "  SQLite version: " + Database.getSqliteVersion() + "\n";
		data += "-->\n\n";
		data += "<!-- Database: " + sDbName + " -->\n";
		foStream.write(data, data.length);

		var xmlDatabase = <{sDbName}/>;
		var xmlColumn, data, xmlTable, colName;
		for(var i = 0; i < allRecords.length; i++)
		{
			var row = allRecords[i];
			xmlTable = <{this.sObjectName}/>;
      for (var iCol = 0; iCol < row.length; iCol++) 
			{
				colName = columns[iCol][0];
				xmlColumn = <{colName}>{row[iCol]}</{colName}>;
				if (bType)
					xmlColumn.@type = types[i][iCol];
				xmlTable.appendChild(xmlColumn);
      }
      xmlDatabase.appendChild(xmlTable);
		}
    data = xmlDatabase.toXMLString();
		foStream.write(data, data.length);
		return allRecords.length;
	},

	doOKImport: function()
	{
		const nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"]
			           .createInstance(nsIFilePicker);
		fp.init(window, "Select File to Import", nsIFilePicker.modeOpen);
		fp.appendFilters("CSV Files", "*.csv");
		fp.appendFilters("SQL Files", "*.sql");
		fp.appendFilters("XML Files", "*.xml");
		fp.appendFilters(nsIFilePicker.filterAll);
		
		var rv = fp.show();
		if (rv != nsIFilePicker.returnOK && rv != nsIFilePicker.returnReplace)
		{
			alert("Please choose a file to import the data from.");
			return false;
		}

		//if chosen then
		var file = Components.classes["@mozilla.org/file/local;1"]
							.createInstance(Components.interfaces.nsILocalFile);
		file.initWithFile(fp.file);
		
		this.msLeafName = fp.file.leafName;
		var iLength = this.msLeafName.indexOf(".");
		if (iLength == -1)
			iLength = this.msLeafName.length;
		this.msLeafName = this.msLeafName.substring(0, iLength);
		// |file| is nsIFile
		var istream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                  .createInstance(Components.interfaces.nsIFileInputStream);
		istream.init(file, 0x01, 0444, 0);
		istream.QueryInterface(Components.interfaces.nsILineInputStream);
		
		// read lines into array
		var line = {}, bHasMore;
		this.sData = "";
		this.lines = [];
		//E4X doesn't support parsing XML declaration(<?xml version=...?>)(bug 336551) 					
		bHasMore = istream.readLine(line); //skipping one line for xml
		this.lines.push(line.value);
		while(bHasMore) 
		{
			bHasMore = istream.readLine(line)
			this.lines.push(line.value); //useful in csv
		  this.sData += line.value;
		}
		istream.close();
		
		var iExportNum = 0;
		switch(this.sExpType)
		{
			case "csv":
				iExportNum = this.readCsvContent();
				break;
			case "sql":
				iExportNum = this.readSqlContent();
				break;
			case "xml":
				iExportNum = this.readXmlContent();
				break;
		}
		this.lines = null;
		this.sData = null;
		if (iExportNum > 0)
		  sm_message(iExportNum + " records imported.", 0x3);
		else
		  sm_message("Import failed.", 0x3);
		  
		return false;
	},
	
	readCsvContent: function()
	{
		var cSeparator = document.getElementById("csv-separator").value;
		if(cSeparator == "other")
		  cSeparator = document.getElementById("csv-separator-text").value;

		var cEncloser = document.getElementById("csv-encloser").value;
		if(cEncloser == "other")
		 cEncloser = document.getElementById("csv-encloser-text").value;
    if (cEncloser == "din")
      cEncloser = '"';

		var bColNames = document.getElementById("csv-column-names").checked;

		var aQueries = [];
		var createdTables = [];
		//determine table name
    var prompts = Components
		               .classes["@mozilla.org/embedcomp/prompt-service;1"]
                   .getService(Components.interfaces.nsIPromptService);
		var check = {value: false};   // default the checkbox to false
		var input = {value: this.msLeafName};   // default the edit field to Bob
		var result = prompts.prompt(null, "Import to Table ",
		                  "Enter the name of the table in which data will be imported:", 
		                  input, null, check);
		var sTabName = input.value;
		//returns true on OK, false on cancel
		if (!result || sTabName.length == 0)
		  return -1;
		sTabName = sm_backquote(sTabName);

		var iRows = this.lines.length;
		var sVals, row, colText, sQuery;
		var iEnc = cEncloser.length;

		var cValEnc = "'";
		if (cEncloser == '"')
			cValEnc = '"';

//will be used if enclosing in single quote is to be provided
//    var re = /[,]|[\"][^\"]*[\"](?!\")|[\'][^\']*[\'](?!\')|[^,]*/g
    var re = /[,]|[\"][^\"]*[\"](?!\")|[^,]*/g
    if (cSeparator == ";")
      re = /[;]|[\"][^\"]*[\"](?!\")|[^;]*/g
    if (cSeparator == "|")
      re = /[\|]|[\"][^\"]*[\"](?!\")|[^\|]*/g
    
    var aCols = [];
		if (iRows > 0)
		{
			row = this.lines[0];
      var aVals = row.match(re);

      var iNumSeparator = 0;
			if (bColNames)
			{
				for (var c = 0; c < aVals.length; c++)
  			{
          if (aVals[c] == cSeparator || aVals[c].length == 0)
            continue;

          if (aVals[c].indexOf(cEncloser) == 0)
    				aVals[c] = aVals[c].substring(iEnc, aVals[c].length - iEnc);

          aCols.push(sm_backquote(aVals[c]));
  			}
			}
			else
			{
  			for (var c = 0; c < aVals.length; c++)
  			{
          if (aVals[c] == cSeparator)
            iNumSeparator++; //count the separators
        }
				
        for (var c = 1; c <= iNumSeparator + 1; c++)
					aCols.push(sm_backquote("col_" + c));
			}
		}
		else
			return -1;

		var sCols = aCols.toString();
		sQuery = "CREATE TABLE " + sTabName + " (" + sCols + ")";
		aQueries.push(sQuery);

		for (var i = bColNames?1:0; i < iRows; i++)
		{
			row = this.lines[i];
      var aVals = row.match(re);

      var iNumSeparator = 0;
      var iCol = 0;
      var aInp = [];
      var aBadLines = [];
      var sNoValue = "''";
			for (var c = 0; c < aVals.length; c++)
			{
        if (aVals[c] == cSeparator)
        {
          iNumSeparator++; //count the separators

          //handle consecutive separators and 
          //the case when first char is a separator
          if (c == 0 || aVals[c-1] == cSeparator)
            aInp.push(sNoValue);

          //separator is not a column value
          continue;
        }

        //ignore nulls
        if (aVals[c].length == 0)
          continue;

        //reached here, means this is a column value
        if (aVals[c].indexOf(cEncloser) == 0)
        {
  				aVals[c] = aVals[c].substring(iEnc, aVals[c].length - iEnc);
  				if (cEncloser == '"')
  				  aVals[c] = aVals[c].replace("\"\"", '"', "g");
  				if (cEncloser == "'")
  				  aVals[c] = aVals[c].replace("\'\'", "'", "g");
  			}
  			
        aVals[c] = sm_makeSqlValue(aVals[c]);
        aInp.push(aVals[c]);
			}
			
			//if aInp has fewer values than expected, 
      //complete the aInp array with empty strings.
      while (aInp.length < aCols.length)
        aInp.push(sNoValue);

      if (aInp.length != aCols.length)
      {
        aBadLines.push(i+1);
        continue;
      }
			sVals = " VALUES (" + aInp.join(",") + ")";
			sQuery = "INSERT INTO " + sTabName + " (" + sCols + ") " + sVals;
//alert(sQuery);
			aQueries.push(sQuery);
		}
		var num = aQueries.length - 1;
		var answer = confirm("Are you sure you want to perform the following operation(s):\nImport Data: Rows = " + num);
		if(answer)
		{
		  if (aBadLines.length > 0)
		  {
        var err = "Failed to import " + aBadLines.length +
                  " lines.\nLine numbers: " + aBadLines.join(", ");
        alert(err);
      }
			var bReturn = Database.executeTransaction(aQueries);
	  	if (bReturn)
				return num;
		}
		return -1;
	},
	
	readSqlContent: function()
	{
	
	},
	
	readXmlContent: function()
	{
		var bType = document.getElementById("xml-type-attribute").checked;

		var aQueries = [];
		var createdTables = [];
		var xmlData = new XML(this.sData);
		XML.ignoreComments = true;
		var sDbName = xmlData.name().localName;
		var iRows = xmlData.*.length();
		var sCols, sVals, iCols, row, colText, sTabName, sQuery;
		for (var i = 0; i < iRows; i++)
		{
			row = xmlData.child(i);
			sTabName = "`" + row.name().localName + "`";
			iCols = row.*.length();
			sCols = "";
			sVals = "";
			for (var j = 0; j < iCols; j++)
			{
				colText = row.child(j).toString();
				if (j != 0)
				{
					sCols += ", ";
					sVals += ", ";
				}
				sCols += "`" + row.child(j).name().localName + "`";
				if (bType)
				{
					if (row.child(j).@type == 3)
						sVals += sm_quote(colText);
					else if (row.child(j).@type == 0)
						sVals += "NULL";
					else if (row.child(j).@type == 1)
						sVals += colText;
					else
						sVals += sm_quote(colText);
				}
				else
					sVals += sm_quote(colText);
			}
			if (createdTables.indexOf(sTabName) == -1)
			{
				sQuery = "CREATE TABLE " + sTabName + " (" + sCols + ")";
				aQueries.push(sQuery);
			}
			createdTables.push(sTabName);
			sQuery = "INSERT INTO " + sTabName + " (" + sCols +
									 ") VALUES (" + sVals + ")";
			aQueries.push(sQuery);
		}
		
		var answer = confirm("Are you sure you want to perform the following operation(s):\nImport Data: Rows = " + iRows);
		if(answer)
		{
			var bReturn = Database.executeTransaction(aQueries);
	  	if (bReturn)
				return iRows;
		}
		return -1;
	}
};
