var StructureManager = 
{
	textboxName: null,
	listboxTable: null,
	
	firstTableName: null,
	aTableNames: null,
	aFieldNames: null,
	
	sCurrentTable: null,
	sObject: null,
	sOperation: null,
	
	aOps: null,

	//could go in preferences, think over
	numOfEmptyColumns: 20, //shown during create table
	tempNamePrefix: "_temp_", // for temp table names during copy, drop column, etc.
			
	initialize: function ()
	{
		this.aOps = [
			["=", "=", ""],
			["<", "<", ""],
			["<=", "<=", ""],
			[">", ">", ""],
			[">=", ">=", ""],
			["contains", 'like "%', '%"'],
			["begins with", 'like "', '%"'],
			["ends with", 'like "%', '"'],
			["IS NULL", "", ""],
			["IS NOT NULL", "", ""]
		];
	},
		
	loadEmptyColumns: function()
	{
		var node = document.getElementById("rows-all");
		this.numOfEmptyColumns = sm_getPreferenceValue("maxColumnsInTable", 20);

		var row = document.getElementById("row-template");
		for(var i = 0; i < this.numOfEmptyColumns; i++)
		{
			var clone = row.cloneNode(true);
			clone.setAttribute("id", "row-" + i);
			clone.setAttribute("style", "");
			var children = clone.childNodes;
			var id;
		   for (var j = 0; j < children.length; j++) 
		   {
		   		id = children[j].getAttribute("id") + "-" + i;
		   		children[j].setAttribute("id", id);
		   };
		  
			node.appendChild(clone);
		}
	},
		
	loadOccupiedColumns: function(sTableName)
	{
		var node = document.getElementById("rows-all");
		this.numOfEmptyColumns = sm_getPreferenceValue("maxColumnsInTable", 20);
		
		var row = document.getElementById("row-template");
		for(var i = 0; i < this.numOfEmptyColumns; i++)
		{
			var clone = row.cloneNode(true);
			clone.setAttribute("id", "row-" + i);
			clone.setAttribute("style", "");
			var children = clone.childNodes;
			var id;
		   for (var j = 0; j < children.length; j++) 
		   {
		   		id = children[j].getAttribute("id") + "-" + i;
		   		children[j].setAttribute("id", id);
		   };
		  
			node.appendChild(clone);
		}
	},
		
	loadCreateTableDialog: function ()
	{
		Database = window.arguments[0];
		var sTableName = window.arguments[1];
		this.sObject = "TABLE";
		
		if (sTableName == null)
    	this.loadEmptyColumns();
    else
    	this.loadOccupiedColumns();
    window.sizeToContent();
	},
		
	loadDialog: function ()
	{
		this.initialize();
		Database = window.arguments[0];
		this.sCurrentTable = window.arguments[1];
		this.sOperation = window.arguments[2];
		var rowid = window.arguments[3];

		switch(this.sOperation)
		{
			case "insert":
				document.title = "Add New Record";
				this.setAcceptAction("doOKAddRecord");
				break;
			case "search":
				document.title = "Search in table: " + this.sCurrentTable;
				this.setAcceptAction("doOKSearch");
				break;
			case "update":
				document.title = "Edit Record";
				this.setAcceptAction("doOKUpdate");
				break;
			case "delete":
				document.title = "Delete Record";
				this.setAcceptAction("doOKDeleteRecord");
				break;
			case "search-view":
				document.title = "Search in view: " + this.sCurrentTable;
				this.setAcceptAction("doOKSearch");
				this.loadForViewRecord(this.sCurrentTable, rowid);
				return;
		}
		
		this.loadForTableRecord();
		this.loadForTables();
		window.sizeToContent();
	},
		
	setAcceptAction: function(sFunctionName)
	{
		var dlg = document.getElementById("dialog-table-operations");
		dlg.setAttribute("ondialogaccept",
				"return StructureManager." + sFunctionName + "();");
	},
	
	loadForTables: function()
	{
		this.sObject = "TABLE";
		var listbox = document.getElementById("tablenames");
    
		this.aTableNames = Database.getObjectList("table");
		PopulateDropDownItems(this.aTableNames, listbox, this.sCurrentTable);

		this.firstTableName = this.aTableNames[0];
	},
		
  selectTable: function(sID)
  {
    var sTable = document.getElementById(sID).value;
		//function names have been assigned in the main load functions
		if(this.sObject == "INDEX")
			this.loadFieldNames(sTable);
	},
	
	loadCreateIndexDialog: function ()
	{
		Database = window.arguments[0];
		this.sCurrentTable = window.arguments[1];

		document.title = "Create Index on Table " + this.sCurrentTable;
		this.sObject = "INDEX";

		this.textboxName = document.getElementById("indexname");
		this.listboxTable = document.getElementById("tabletoindex");

		this.aTableNames = Database.getObjectList("table");
		PopulateDropDownItems(this.aTableNames, this.listboxTable, null);
		
		this.firstTableName = this.aTableNames[0];
		this.loadFieldNames(this.sCurrentTable);
	},
		
	loadCreateViewDialog: function ()
	{
		Database = window.arguments[0];
		this.sCurrentTable = window.arguments[1];

		document.title = "Create View";
		this.sObject = "VIEW";
	},
	
	loadCreateTriggerDialog: function ()
	{
		Database = window.arguments[0];
		this.sCurrentTable = window.arguments[1];

		this.sObject = "trigger";
		this.listboxTable = document.getElementById("tabletoindex");

		this.aTableNames = Database.getObjectList("table");
		PopulateDropDownItems(this.aTableNames, this.listboxTable, null);
	},

  loadTableNames: function()
  {
		this.aTableNames = Database.getObjectList("table");
    PopulateDropDownItems(this.aTableNames, this.listboxTable, null);
  },

  loadFieldNames: function(sTableName)
  {
		var info = Database.getTableColumns(sTableName);
		var cols = info[0];
		this.aFieldNames = [], aTypes = [];
		for(var i = 0; i < cols.length; i++)
		{
			this.aFieldNames.push(cols[i][info[1]["name"][0]]);
			aTypes.push(cols[i][info[1]["type"][0]]);
		}
		var grbox = document.getElementById("definecolumns");

		while (grbox.firstChild) 
		{
			 grbox.removeChild(grbox.firstChild);
		}
		var cap = document.createElement("caption");
		cap.setAttribute("label", "Define Index Columns");
		grbox.appendChild(cap);
			
		for(var i = 0; i < this.aFieldNames.length; i++)
		{
			var radgr = document.createElement("radiogroup");
			radgr.setAttribute("id", "rad-" + (i+1));

			var hbox = document.createElement("hbox");
			hbox.setAttribute("flex", "1");
			hbox.setAttribute("style", "margin:2px 3px 2px 3px");
			hbox.setAttribute("align", "right");
			
			var lbl = document.createElement("label");
			lbl.setAttribute("value", (i+1) + ". " + this.aFieldNames[i]);
			lbl.setAttribute("style", "padding-top:5px;width:100px;");
			lbl.setAttribute("accesskey", (i+1));
			lbl.setAttribute("control", "rad-" + (i+1));
			hbox.appendChild(lbl);
			
			var radio;
			radio = document.createElement("radio");
			radio.setAttribute("label", "Do not use");
			radio.setAttribute("selected", "true");
			radio.setAttribute("value", "");
			hbox.appendChild(radio);

			radio = document.createElement("radio");
			radio.setAttribute("label", "Ascending");
			radio.setAttribute("value", this.aFieldNames[i] + " ASC");
			hbox.appendChild(radio);

			radio = document.createElement("radio");
			radio.setAttribute("label", "Descending");
			radio.setAttribute("value", this.aFieldNames[i] + " DESC");
			hbox.appendChild(radio);

			radgr.appendChild(hbox);
			
			grbox.appendChild(radgr);
		}
	},

	doOK: function()
	{
	},
		
	modifyTable: function(sOperation, sTable, sColumn)
	{
//		var s = sql_tokenizer("CREATE TABLE newtable	 ('col1' INTEGER NOT NULL , 'col2' TEXT NOT NULL  DEFAULT 'hello' , 'col3' VARCHAR, 'col4' INTEGER NOT NULL  DEFAULT '100' , PRIMARY KEY ('col1','col4') )");
//		var x = "";
//		for(var i=0; i < s.length;i++)
//			x += s[i][0] + " = " + s[i][1] + "\n";
//		alert(x);
//		return;
		if (sOperation == "addColumn")
		{
			var aQueries = [];
			var coldef = sm_backquote(sColumn["name"]) + " " + sColumn["type"];
			if (sColumn["notnull"]) coldef += " NOT NULL ";
			if(sColumn["dflt_value"].toUpperCase() != g_strForNull.toUpperCase())
			{
				coldef += " DEFAULT " + sColumn["dflt_value"];
			}
			aQueries.push("ALTER TABLE " + sm_backquote(sTable) + " ADD COLUMN " + coldef);
			var bReturn = this.confirmAndExecute(aQueries, "Add Column to Table " + sTable, "confirm.otherSql");
	  	return bReturn;
		}
		if (sOperation == "dropColumn")
		{
			//get the columns info
			var info = Database.getTableColumns(sTable);
			var cols = info[0];

			var aPK = [];
			var aCols = [];
			var aColNames = [];
			for(var i = 0; i < cols.length; i++)
			{
				var colname = cols[i][info[1]["name"][0]];
				if (colname == sColumn)
					continue;
				colname = sm_backquote(colname);
        aColNames.push(colname);

				var col = [i, colname];
				aCols.push(col);
				var primarykey = cols[i][info[1]["pk"][0]];
				if(primarykey == 1)
					aPK.push(colname);
			}
			var colList = aColNames.toString();

      var aColDefs = [];
			for(var i = 0; i < aCols.length; i++)
			{
				var j = aCols[i][0]
				var datatype = cols[j][info[1]["type"][0]];

				var txtNull = " NOT NULL ";
				if(cols[j][info[1]["notnull"][0]] == 0)
					txtNull = "";

				var defaultvalue = cols[j][info[1]["dflt_value"][0]];
				var defaultType = info[2][j][info[1]["dflt_value"][0]];
				if(defaultType == 0)
					defaultvalue = ""
				else
					defaultvalue = " DEFAULT " + defaultvalue + " ";


				var pk = "";
				if(aPK.length == 1 && aPK[0] == aCols[i][1])
					pk = " PRIMARY KEY ";
				var col = aCols[i][1] + " " + datatype + 
							pk + txtNull + defaultvalue;
				aColDefs.push(col);
			}
			var coldef = aColDefs.toString();

			//this is the primary key constraint on multiple columns
			var constraintPK = "";
			if(aPK.length > 1)
				constraintPK = ", PRIMARY KEY (" + aPK.toString() + ") ";

			coldef += constraintPK;

////////////////////////////
			var sTab = sm_backquote(sTable);	
			var sTempTable = this.tempNamePrefix + sTable;
			sTempTable = sm_backquote(sTempTable);
			
			var aQueries = [];
			aQueries.push("ALTER TABLE " + sTab + " RENAME TO "	+ sTempTable);
			aQueries.push("CREATE TABLE " + sTab + " (" + coldef + ")");		
			aQueries.push("INSERT INTO " + sTab + " SELECT " + colList
						+ " FROM " + sTempTable);		
			aQueries.push("DROP TABLE " + sTempTable);		
			var bReturn = this.confirmAndExecute(aQueries, "Drop Column from " + sTable, "confirm.otherSql");
	  	return bReturn;
		}
		//should not come here
		return false;
	},

	copyTable: function(sTableName)
	{
    var prompts = Components
		               .classes["@mozilla.org/embedcomp/prompt-service;1"]
                   .getService(Components.interfaces.nsIPromptService);
		var check = {value: false};   // default the checkbox to false
		var input = {value: ""};   // default the edit field to Bob
		var result = prompts.prompt(null, "Copy Table " + sTableName,
		                  "Enter the new name of the table", input, 
											"Only Structure (data will not be copied)", 
											check);
		var sNewTable = input.value;
		sNewTable = sm_backquote(sNewTable);
		var bOnlyStructure = check.value;
		//returns true on OK, false on cancel
		if (!result || sNewTable.length == 0)
		  return false;
		  
		var r_sql = Database.getMasterInfo(sTableName, "sql");

		var sTab = sm_backquote(sTableName);	
		var sTempTable = this.tempNamePrefix + sTableName;
		sTempTable = sm_backquote(sTempTable);
		var aQueries = [];
		aQueries.push("ALTER TABLE " + sTab + " RENAME TO "	+ sTempTable);
		aQueries.push(r_sql);
		aQueries.push("ALTER TABLE " + sTab + " RENAME TO "	+ sNewTable);
		aQueries.push("ALTER TABLE " + sTempTable + " RENAME TO "	+ sTab);
		if(!bOnlyStructure)
		{
			aQueries.push("INSERT INTO " + sNewTable + " SELECT * FROM " + sTab);
		}
		
		var bReturn = this.confirmAndExecute(aQueries, "Copy the Table: " + sTableName, "confirm.otherSql");
  	return bReturn;
	},

	renameTable: function(sTableName)
	{
    var prompts = Components
		               .classes["@mozilla.org/embedcomp/prompt-service;1"]
                   .getService(Components.interfaces.nsIPromptService);
		var check = {value: false};   // default the checkbox to false
		var input = {value: ""};   // default the edit field to Bob
		var result = prompts.prompt(null, "Rename Table " + sTableName,
		                  "Enter the new name of the table", 
		                  input, null, check);
		var sNewTable = input.value;
		sNewTable = sm_backquote(sNewTable);
		//returns true on OK, false on cancel
		if (!result || sNewTable.length == 0)
		  return false;
		  
		var sTab = sm_backquote(sTableName);	
		var sQuery = "ALTER TABLE " + sTab + " RENAME TO " + sNewTable;
		
		return this.confirmAndExecute([sQuery], "Rename table " + sTableName, "confirm.otherSql");
	},

	//emptyTable: deletes all the records in the table
	emptyTable: function(sTableName)
	{
		var sQuery = "DELETE FROM " + sm_backquote(sTableName);
		return this.confirmAndExecute([sQuery], "Delete All Records from "
												+ sTableName, "confirm.otherSql");
	},

	analyzeTable: function(sTableName)
	{
		var sQuery = "ANALYZE " + sTableName;
		return this.confirmAndExecute([sQuery], "Analyze table " + sTableName);
	},

	deleteFromTable: function(sTableName,	colName, aRowIds)
	{
		var criteria = colName + " IN (" + aRowIds.toString() + ")";
		var sQuery = "DELETE FROM " + sm_backquote(sTableName) + " WHERE " + criteria;
		return this.confirmAndExecute([sQuery], "Delete records from " + sTableName);
	},

	doOKCreateTable: function()
	{
		var name = document.getElementById("tablename").value;
		if(name == "")
		{
			alert("Table Name cannot be null");
			return false;
		}
		if(name.indexOf("sqlite_") == 0)
		{
			alert("Table Name cannot begin with sqlite_");
			return false;
		}
		name = sm_backquote(name);

		var iTotalRows = this.numOfEmptyColumns;
		var aPK = [];
		var aCols = [];
		for(var i = 0; i < iTotalRows; i++)
		{
			var colname = document.getElementById("colname-" + i).value;
			if(colname.length == 0 || colname == null || colname == undefined)
			{
				continue;
			}
			if(colname == "rowid" || colname == "_rowid_" || colname == "oid")
			{
				alert("Column Name cannot be one of rowid, _rowid_, oid");
				return false;
			}
			colname = sm_backquote(colname);
			var col = [i, colname];
			aCols.push(col);
		}
		for(var i = 0; i < aCols.length; i++)
		{
			var j = aCols[i][0];
			var primarykey = document.getElementById("primarykey-" + j).checked;
			if(primarykey)
				aPK.push(aCols[i][1]);
		}
		
		var coldef = "";
		for(var i = 0; i < aCols.length; i++)
		{
			var j = aCols[i][0]
			var datatype = document.getElementById("datatype-" + j).value;
			var txtNull = " NOT NULL ";
			if(document.getElementById("allownull-" + j).checked)
				txtNull = "";
				
			var defaultvalue = document.getElementById("defaultvalue-" + j).value;
			defaultvalue = sm_makeSqlValue(defaultvalue);
			if(defaultvalue != g_strForNull)
				defaultvalue = " DEFAULT " + defaultvalue;
			else
				defaultvalue = ""
			
			var pk = "";
			if(aPK.length == 1 && aPK[0] == aCols[i][1])
				pk = " PRIMARY KEY ";
			var col = aCols[i][1] + " " + datatype + 
						pk + txtNull + defaultvalue;
			if(i > 0) 
				col = ", " + col;
			
			coldef += col; 
		}

		//this is the primary key constraint on multiple columns
		var constraintPK = "";
		if(aPK.length > 1)
			constraintPK = ", PRIMARY KEY (" + aPK.toString() + ") ";

		coldef += constraintPK;
		
		var txtTemp = "";
		if(document.getElementById("temptable").checked)
			txtTemp = " TEMP ";
		
		var txtExist = "";
		if(document.getElementById("ifnotexists").checked)
			txtExist = " IF NOT EXISTS ";
			
		var sQuery = "CREATE " + txtTemp + " TABLE " + txtExist + name + " (" + coldef + ")";
		return this.confirmAndExecute([sQuery], "Create table " + name, "confirm.create");
	},

	doOKCreateView: function()
	{
		var name = document.getElementById("objectName").value;
		if(name == "")
		{
			alert("Name cannot be null");
			return false;
		}
		name = "'" + name + "'";

		var txtTemp = "";
		if(document.getElementById("tempObject").checked)
			txtTemp = " TEMP ";
			
		var txtExist = "";
		if(document.getElementById("ifnotexists").checked)
			txtExist = " IF NOT EXISTS ";
				
		var selectStatement = document.getElementById("txtSelectStatement").value;
		if(selectStatement == "")
		{
			alert("Name cannot be null");
			return false;
		}

		var sQuery = "CREATE " + txtTemp + " VIEW " + txtExist + name 
					+ " AS " + selectStatement;
		return this.confirmAndExecute([sQuery], "Create View " + name, "confirm.create");
	},

	doOKCreateTrigger: function()
	{
		var name = document.getElementById("objectName").value;
		if(name == "")
		{
			alert("Name cannot be null");
			return false;
		}
		name = "'" + name + "'";

		var txtTemp = "";
		if(document.getElementById("tempObject").checked)
			txtTemp = " TEMP ";
			
		var txtExist = "";
		if(document.getElementById("ifnotexists").checked)
			txtExist = " IF NOT EXISTS ";
				
		var txtForEachRow = "";
		if(document.getElementById("foreachrow").checked)
			txtForEachRow = " FOR EACH ROW ";
				
		var whenExpression = document.getElementById("txtWhenExpression").value;
		if(whenExpression == "" || whenExpression == null)
		{
			whenExpression = "";
		}
		else
			whenExpression = " WHEN " + whenExpression + " ";

		var steps = document.getElementById("txtTriggerSteps").value;
		if(steps == "")
		{
			alert("Trigger steps cannot be empty");
			return false;
		}

		var txtTable = document.getElementById("tabletoindex").value;
		var txtTime = document.getElementById("triggerTime").selectedItem.label;
		var txtEvent = document.getElementById("dbEvent").selectedItem.label;

		var sQuery = "CREATE " + txtTemp + " TRIGGER " + txtExist + name 
					+ " " + txtTime + " " + txtEvent + " ON " + txtTable + txtForEachRow 
					+ whenExpression + " BEGIN " + steps + " END";
		return this.confirmAndExecute([sQuery], "Create Trigger " + name, "confirm.create");
	},

	doOKCreateIndex: function()
	{
		var name = this.textboxName.value;
		if(name == "")
		{
			alert("Name cannot be null");
			return false;
		}

		var tbl = this.sCurrentTable;
		var dup = document.getElementById("duplicatevalues").selectedItem.value;
		
		var radgr, radval;
		var cols = "";
		for(var i = 0; i < this.aFieldNames.length; i++)
		{
			radgr = document.getElementById("rad-" + (i+1));
			radval = radgr.value;
			if(radval != "")
			{
				if(cols != "")
					radval = ", " + radval;
				
				cols = cols + radval;
			}
		}	
		if(cols == "")
		{
			alert("No Fields selected");
			return false;
		}
		
		var sQuery = "CREATE " + dup + " INDEX '" + name + "' ON '" + tbl +
						"' (" + cols + ")";
		return this.confirmAndExecute([sQuery], "Create Index " + name, "confirm.create");
	},
	
	//sObject = TABLE/INDEX/COLLATION; thus we have a common function
	reindexObject: function(sObjectType, sObjectName)
	{
		var sQuery = "REINDEX '" + sObjectName + "'";
		return this.confirmAndExecute([sQuery], "Reindex " + sObjectType +
		                                    " " + sObjectName);
	},

	//sObject = TABLE/INDEX/VIEW/TRIGGER; thus we have a common function
	dropObject: function(sObjectType, sObjectName)
	{
		var sQuery = "DROP " + sObjectType + " " + sm_backquote(sObjectName);
		return this.confirmAndExecute([sQuery], sQuery);
	},

	onSelectOperator: function(selectedOp, sFieldName)
	{
		//alert(selectedOp);
		var ctrl = "ctrl-tb-" + sFieldName;
		var node = document.getElementById(ctrl);
//		node.hidden = false;
		switch (this.aOps[selectedOp][0])
		{
			case "IS NULL":
			case "IS NOT NULL":
				node.disabled = true;
				break;
			default:
				node.disabled = false;
		}
	},
	
	loadForTableRecord: function()
	{
		document.getElementById("tablenames").setAttribute("disabled", true);
		var sTableName = this.sCurrentTable;

		var info = Database.getTableColumns(sTableName);
		var cols = info[0];
		this.aFieldNames = [];
		var aTypes = [];
		for(var i = 0; i < cols.length; i++)
		{
			this.aFieldNames.push(cols[i][info[1]["name"][0]]);
			aTypes.push(cols[i][info[1]["type"][0]]);
		}
		
		var row, cols, rowTypes, cols1 = [];
		if(this.sOperation == "update" || this.sOperation == "delete")
		{
			var rowid = window.arguments[3];
			var sql = "SELECT * from " + sm_backquote(sTableName) + " where " + rowid;
			Database.selectQuery(sql);
			row = Database.getRecords()[0];
			cols = Database.getColumns();
			rowTypes = Database.getRecordTypes()[0];
			for (var j = 0; j < this.aFieldNames.length; j++)
			{
				for (var k = 0; k < cols.length; k++)
				{
					if (cols[k][0] == this.aFieldNames[j])
						cols1[j] = k;
						
				}
			}
		}

		var grbox = document.getElementById("columnEntryFields");
		ClearElement(grbox);
		var cap = document.createElement("caption");
		cap.setAttribute("label", "Enter Field Values");
		grbox.appendChild(cap);
		
		for(var i = 0; i < this.aFieldNames.length; i++)
		{
			var hbox = document.createElement("hbox");
			hbox.setAttribute("flex", "0");
			hbox.setAttribute("style", "margin:2px 3px 2px 3px");
			
			var lbl = document.createElement("label");
			var lblVal = (i+1) + ". " + this.aFieldNames[i];
			lblVal += " ( " + aTypes[i] + " )"; 
			lbl.setAttribute("value", lblVal);
			lbl.setAttribute("style", "padding-top:5px;width:25ex");
			lbl.setAttribute("accesskey", (i+1));
			lbl.setAttribute("control", "ctrl-" + this.aFieldNames[i]);
			hbox.appendChild(lbl);
								
			var spacer = document.createElement("spacer");
			spacer.flex = "1";
			hbox.appendChild(spacer);

			if(this.sOperation == "search")
			{
				var vb = this.getSearchMenuList(this.aFieldNames[i]);
				hbox.appendChild(vb);
			}
			
			var inp1 = this.getInputField(this.aFieldNames[i]);

			if(this.sOperation == "update" || this.sOperation == "delete")
			{
				var fldVal = row[cols1[i]];
				if (rowTypes[cols1[i]] == 3 && !sm_getPreferenceValue("implicitlyQuote", true))
					fldVal = sm_quote(fldVal);
				inp1.value = fldVal;
			}

			hbox.appendChild(inp1);

			var vb = this.getInputToggleImage(this.aFieldNames[i]);
			hbox.appendChild(vb);
			
			grbox.appendChild(hbox);
		}
		window.sizeToContent();
	},

	getSearchMenuList: function(sField)
	{
		var ml = document.createElement("menulist");
		ml.setAttribute("id", "op-" + sField);
		ml.setAttribute("sizetopopup", "always");
		ml.setAttribute("style", "max-width: 25ex");
		ml.setAttribute("oncommand", 
			"StructureManager.onSelectOperator(this.value, '" +	sField + "')");
    
		var mp = document.createElement("menupopup");

		for(var iOp = 0; iOp < this.aOps.length; iOp++)
		{
			var mi = document.createElement("menuitem");
			mi.setAttribute("label", this.aOps[iOp][0]);
			mi.setAttribute("value", iOp);
			if (iOp == 0)
				mi.setAttribute("selected", "true");
			mp.appendChild(mi);
		}
		ml.appendChild(mp);
		var vb = document.createElement('vbox');
		vb.appendChild(ml);
	  return vb;
	},

	getInputToggleImage: function(sField)
	{
			var vb = document.createElement('vbox');
			var img = document.createElement('image');
			img.setAttribute('id', 'img-' + sField);
			img.setAttribute('src', 'chrome://sqlitemanager/skin/images/expand.png');
  		img.setAttribute('style', 'margin-top:5px;');
			img.setAttribute('onclick', 'StructureManager.collapseInputField("' + sField + '")');
			vb.appendChild(img);
		  return vb;
	},

	getInputField: function(sField)
	{
			var mp1 = document.getElementById("defaultvalue-tb");
			var inp1 = mp1.cloneNode(true);
			inp1.setAttribute("id", "ctrl-tb-" + sField);
			inp1.setAttribute("flex", "30");
			inp1.setAttribute("value", "");
			inp1.setAttribute("hidden", "false");
		  inp1.setAttribute("height", "22px");
		  return inp1;
	},

	collapseInputField: function(id)
	{
		var inptb = document.getElementById("ctrl-tb-" + id);
		var iLines = inptb.getAttribute("rows");

    var img = document.getElementById("img-" + id);
		if (iLines == 1)
		{
		  inptb.setAttribute("rows", 4);
		  inptb.removeAttribute("height");
			img.setAttribute('src', 'chrome://sqlitemanager/skin/images/collapse.png');
		}
		else
		{
		  inptb.setAttribute("rows", 1);
		  inptb.setAttribute("height", "22px");
			img.setAttribute('src', 'chrome://sqlitemanager/skin/images/expand.png');
		}
	},

	loadForViewRecord: function(sViewName, aColumns)
	{
		document.getElementById("tablenames").hidden = true;
		document.getElementById("label-name").value = "View Name : " + sViewName;

		this.aFieldNames = aColumns[0];
		var aTypes = aColumns[1];

		var grbox = document.getElementById("columnEntryFields");
		ClearElement(grbox);
		var cap = document.createElement("caption");
		cap.setAttribute("label", "Enter Field Values");
		grbox.appendChild(cap);
		
		for(var i = 0; i < this.aFieldNames.length; i++)
		{
			var hbox = document.createElement("hbox");
			hbox.setAttribute("flex", "1");
			hbox.setAttribute("style", "margin:2px 3px 2px 3px");
			
			var lbl = document.createElement("label");
			var lblVal = (i+1) + ". " + this.aFieldNames[i];
			lblVal += " ( " + aTypes[i] + " )"; 
			lbl.setAttribute("value", lblVal);
			lbl.setAttribute("style", "padding-top:5px;width:25ex");
			lbl.setAttribute("accesskey", (i+1));
			lbl.setAttribute("control", "ctrl-" + this.aFieldNames[i]);
			hbox.appendChild(lbl);
								
			var spacer = document.createElement("spacer");
			spacer.flex = "1";
			hbox.appendChild(spacer);

			var vb = this.getSearchMenuList(this.aFieldNames[i]);
			hbox.appendChild(vb);

			var inp = this.getInputField(this.aFieldNames[i]);
			hbox.appendChild(inp);

			var vb = this.getInputToggleImage(this.aFieldNames[i]);
			hbox.appendChild(vb);

			grbox.appendChild(hbox);
		}
	},

	doOKAddRecord: function()
	{
		var colPK = null;
		var rowidcol = Database.getTableRowidCol(this.sCurrentTable);
		if (rowidcol["name"] != "rowid")
			colPK = rowidcol["name"];

		var aDefCols = Database.getTableColumnsWithDefaultValue(this.sCurrentTable);
		if (colPK != null)
			aDefCols.push(colPK);

		var inpval, fld;
		var aCols = [];
		var aVals = [];
		for(var i = 0; i < this.aFieldNames.length; i++)
		{
			var ctrltb = document.getElementById("ctrl-tb-" + this.aFieldNames[i]);
			inpval = ctrltb.value;

			//this is to allow autoincrement of primary key columns 
			//and accept default values where available
			if (aDefCols.indexOf(this.aFieldNames[i]) >= 0)
				if(inpval.toUpperCase() == g_strForNull.toUpperCase() || inpval.length == 0)
				  continue;

			inpval = sm_makeSqlValue(inpval);
			fld = sm_backquote(this.aFieldNames[i]);
			aCols.push(fld);
			aVals.push(inpval);
		}	
		var cols = "(" + aCols.toString() + ")";
		var vals = "(" + aVals.toString() + ")";
		
		var sQuery = "INSERT INTO " + sm_backquote(this.sCurrentTable) + " " + cols +
					" VALUES " + vals;
		return this.confirmAndExecute([sQuery], "ADD a NEW RECORD", "confirm.records");
	},
		
	doOKUpdate: function()
	{
		var criteria = window.arguments[3];
		var inpval, fld;
		var cols = "";
		var vals = "";
		for(var i = 0; i < this.aFieldNames.length; i++)
		{
			var ctrltb = document.getElementById("ctrl-tb-" + this.aFieldNames[i]);
			inpval = ctrltb.value;
			inpval = sm_makeSqlValue(inpval);

			fld = sm_backquote(this.aFieldNames[i]);
			
			if(i != 0)
			{
				fld = ", " + fld;
			}
			cols = cols + fld + " = " + inpval;
		}	
		
		var sQuery = "UPDATE " + sm_backquote(this.sCurrentTable) + " SET " + cols +
					" WHERE " + criteria;
		return this.confirmAndExecute([sQuery], "UPDATE RECORD", "confirm.records");
	},

	doOKDeleteRecord: function()
	{
		var criteria = window.arguments[3];
		var sQuery = "DELETE FROM " + sm_backquote(this.sCurrentTable) + " WHERE " + criteria;
		return this.confirmAndExecute([sQuery], "DELETE RECORD");
	},

	//used for searching within table/view
	doOKSearch: function()
	{
		var inpval, opval, fld;
		var where = "";
		for(var i = 0; i < this.aFieldNames.length; i++)
		{
			var ctrltb = document.getElementById("ctrl-tb-" + this.aFieldNames[i]);
			inpval = ctrltb.value;
			if (inpval.length == 0)
				continue;
			opval = document.getElementById("op-" + this.aFieldNames[i]).value;
//			if (this.aOps[opval][0] == g_strIgnore)
//				continue;

			switch (this.aOps[opval][0])
			{
				case "IS NULL":
					inpval = " ISNULL ";
					break;
				case "IS NULL":
					inpval = " NOTNULL ";
					break;
				default:
					inpval = this.aOps[opval][1] + inpval + this.aOps[opval][2];
					break;
			}
			inpval = sm_backquote(this.aFieldNames[i]) + " " + inpval;

			if(where.length > 0)
				inpval = " AND " + inpval;

			where += inpval;
		}
		var extracol = "";
		if (this.sOperation == "search") //do this for table, not for view
		{	
			var rowidcol = Database.getTableRowidCol(this.sCurrentTable);
			if (rowidcol["name"] == "rowid")
				extracol = " rowid, ";
		}
		if(where.length > 0)
			where = " WHERE " + where;
		var sQuery = "SELECT " + extracol + " * FROM " + sm_backquote(this.sCurrentTable) + where;

//		  var answer = confirm("Your query is: " + sQuery + ". Want to execute it?");
		var answer = true;
	  if(answer)
		{
			//the value of tempSearchQuery should differ from existing one for
			//the change event to fire. We force it to be different by appending space
			//if needed.
			var sTemp = sm_prefsBranch.getCharPref("tempSearchQuery", where);
			if (sTemp == where)
				where += " ";
			sm_prefsBranch.setCharPref("tempSearchQuery", where);
		}
		//return false so that window stays there for more queries
		//the user must cross, escape or cancel to exit
		return false;
	},
		
	confirmAndExecute: function(aQueries, sMessage, confirmPrefName)
	{
		var ask = "Are you sure you want to perform the following operation(s):";
		var sQuery = "";
		for(var i = 0; i < aQueries.length; i++)
			sQuery += aQueries[i] + "\n";
			
	  var answer = true, bConfirm = true;
	  if (confirmPrefName != undefined)
	  	bConfirm = sm_prefsBranch.getBoolPref(confirmPrefName, true);
	  else
	  	bConfirm = sm_prefsBranch.getBoolPref("confirm.otherSql", true);

	  if (bConfirm)
			answer = confirm(ask + "\n" + sMessage + "\nSQL: " + sQuery);
		if(answer)
		{
			var bReturn = Database.executeTransaction(aQueries);
		  return bReturn;
		}
		return false;
	},
	
	doCancel: function()
	{
	  return true;
	}
};
